/**********************************************************
kMMenu for E2 v0.1b

Written  by Strelok Vlad Kolerts
5/12/2009
Email: admin@mobsk.org.ua
ICQ: 497123239
***********************************************************/

#include "Registry.h"
extern void Debug( QString print);
extern QStringList lnga_id, lnga_name;

Registry::Registry(QString openfile, QString Path)
{
	regfile = openfile;
	it_path = Path;
	icon_size=48;
	bicon_size=56;
	update();
}
void Registry::rename(QString Id, QString Name)
{
	for (int a = 0; a < total; a++)
	{
		if (Id.compare(data[a].Id) == 0)
		{
			data[a].Name=Name;
		}
	}
}
void Registry::remove(QString Id)
{
	for (int a = 0; a < total; a++)
	{
		if (Id.compare(data[a].Id) == 0)
		{
			data[a].Id="Deleted";
		}
	}
}
void Registry::add(data_struct dat)
{
	data.push_back(dat);
	total++;
}
void Registry::search_add(QString id)
{
	data_struct tmp;
	QString Exec, dir, java;
	ZConfig cfg(regfile, true);
	tmp.Id=id;
	tmp.AppId=cfg.readEntry(id, "AppId", "");
	tmp.Name=cfg.readEntry(id, "Name", "");
	dir=cfg.readEntry(id, "Directory", "");
	java=cfg.readEntry(id, "JavaId", "");
	tmp.icon=cfg.readEntry(id, "BigIcon", "");
	tmp.AniIcon=cfg.readEntry(id, "AniIcon", "");
	tmp.Exec=cfg.readEntry(id, "Exec", "");
	tmp.Type=atoi(cfg.readEntry(id, "Type", "0"));
	if(regfile==PHONE_REG)
		tmp.Place=2;
	else
		tmp.Place=3;
	if(java=="-1")
	{
		it_path+="QTDownLoad/"+dir+"/";
		Exec=it_path;
	}
	else
	{
		Exec="/usr/SYSjava/kvm -launch "+java;
		it_path=dir+"/";
	}
	tmp.Exec=Exec+tmp.Exec;
	tmp.Path=it_path;
	data.push_back(tmp);
	total++;
}

bool Registry::search(data_struct &regdata, QString searchid)
{
	if (error == 1)
		return false;
	for (int a = 0; a < total; a++)
	{
		if (searchid.compare(data[a].Id) == 0)
		{
			regdata.Id = data[a].Id;
			regdata.Name = "";
			for(int i=0;i<(int)lnga_id.count();i++)
			{
				if(lnga_id[i]==regdata.Id)
				{
					regdata.Name=lnga_name[i];
					break;
				}
			}
			if(regdata.Name=="")
				regdata.Name = data[a].Name;
			regdata.AppId = data[a].AppId;
			regdata.Exec = data[a].Exec;
			regdata.Path = data[a].Path;
			regdata.Type = data[a].Type;
			regdata.Place = data[a].Place;
			regdata.AniIcon = data[a].AniIcon;
			regdata.icon = data[a].icon;
			
			if(!data[a].BigIcon.isNull())
			{
				Debug("Registry::quik speed of loading icon"+data[a].icon);
				regdata.BigIcon=data[a].BigIcon;
				regdata.Icon=data[a].Icon;
			}
			else
			{
				Debug("Registry::low speed of loading icon"+data[a].icon);
				if(kGetMime(data[a].icon)!="g" && data[a].icon!=NULL)
				{
					regdata.BigIcon.convertFromImage(QImage(data[a].Path+data[a].icon).smoothScale(bicon_size, bicon_size));
					regdata.Icon.convertFromImage(QImage(data[a].Path+data[a].icon).smoothScale(icon_size, icon_size));
				}
				else
				{
					regdata.BigIcon.convertFromImage(r.getIcon(data[a].icon).convertToImage().smoothScale(bicon_size, bicon_size));
					regdata.Icon.convertFromImage(r.getIcon(data[a].icon).convertToImage().smoothScale(icon_size, icon_size));
				}
				data[a].BigIcon=regdata.BigIcon;
				data[a].Icon=regdata.Icon;
			}
			return true;
		}
	}
	return false;
}

void Registry::update()
{
	QString line, Exec, item_path, dir, java;
	data_struct tmp;
	total = 0;
	data.clear();
	bool Type=0;
	tmp.Place=0;
	tmp.Type=0;
	
	QFile file(regfile);
	if( file.open(IO_ReadOnly) )		
	{
		Debug("Registry::Reading "+regfile);
		QTextStream stream( &file );
		stream.setEncoding ( QTextStream::UnicodeUTF8 );
		while (!stream.eof())
		{
			line=stream.readLine();
			if (line.left(1)=="[" && line.right(1)=="]")
			{
				tmp.Id=line.mid(1, line.length()-2);
			}
			if (!tmp.Id.isEmpty())
			{
				if (line.find("AppID")==0)
				{
					tmp.AppId=line.mid(9, line.length()-10);
				}
				else if (line.find("Name")==0)
				{
					tmp.Name=line.mid(7, line.length());
				}
				else if (line.find("Directory")==0)
				{
					dir=line.mid(12, line.length());
				}
				else if (line.find("JavaId")==0)
				{
					java=line.mid(9, line.length());
				}
				else if(line.find("AniIcon")==0)
				{
					tmp.AniIcon=line.mid(10, line.length());
				}
				else if (line.find("BigIcon")==0)
				{
					tmp.icon=line.mid(10, line.length());
				}
				else if (line.find("Exec")==0)
				{
					tmp.Exec=line.mid(7, line.length());
				}
				else if (line.find("Type") == 0)
				{
					tmp.Type=atoi(line.mid(7, line.length()));
					Type=1;
				}
				if (!tmp.Name.isEmpty() && Type)
				{
					item_path=it_path;
					if(regfile==USER_REG)
						tmp.Place=1;
					if(regfile==PHONE_REG)
						tmp.Place=2;
					if(regfile==MMC_REG)
						tmp.Place=3;
					if(regfile==SYS_REG || regfile==USER_REG)
					{
						Exec=item_path+dir+"/";
						item_path="";
					}
					else
					{
						if(java=="-1")
						{
							item_path+="QTDownLoad/"+dir+"/";
							Exec=item_path;
						}
						else
						{
							Exec="/usr/SYSjava/kvm -launch "+java;
							item_path=dir+"/";
						}
					}
					tmp.Exec=Exec+tmp.Exec;
					tmp.Path=item_path;
					//qDebug(tmp.Id+" "+tmp.Name+" "+tmp.icon+" "+tmp.Exec);
					data.push_back(tmp);
					tmp.Id="";
					tmp.AppId="";
					tmp.Name="";
					tmp.AniIcon="";
					tmp.icon="";
					tmp.Exec="";
					tmp.Place=0;
					tmp.Type=0;
					item_path="";
					java="";
					Exec="";
					dir="";
					Type=0;
					
					total++;
				}
			}
		}
		file.close();
		Debug("Registry::ok");
	}
	else
	{
		Debug("Registry::Open "+regfile+" failed.");
	}
	if (total == 0)
		error = 1;
	else
		error = 0;
}

void Registry::setIconSize(int s, int b)
{
	icon_size = s;
	bicon_size= b;
	for(int i = 0; i < total; i++)
	{
		data[i].BigIcon=QPixmap(0,0);
		data[i].Icon=QPixmap(0,0);
	}
}

QString Registry::kGetMime(const char*ChineseString)
{
	QString str = ChineseString;
	int i = str.findRev (".");
	if (i==-1) return false;
	else return str.mid(i+1,str.length()-i);
}
