//
// C++ Implementation: ZAboutDlg
//
// Description:
//
//
// Author: root <root@andLinux>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "BaseDlg.h"
#include "ZProcInfo.h"
#include "zTaskMan.h"
#include "lng.h"

#include <ZLabel.h>
#include <QDaemonApp.h>
#include <ZSoftKey.h>
#include <ZScrollPanel.h>
#include <qfile.h>
#include <qtextstream.h>
#include <qfont.h>
#include <ZSkinBase.h>

extern ZTaskMan *zTaskMan;
extern QDaemonApp *app;
extern ZLng* lng;

ZProcInfoDlg::ZProcInfoDlg(int pid)
    :MyBaseDlg()
{
	zTaskMan->toLog("ZProcInfoDlg: Start");
	QWidget *myWidget = new QWidget ( this ); 
  	
  	setMainWidgetTitle(lng->LNG_DLG_PROCINFO);
  	
  	zTaskMan->toLog("ZProcInfoDlg: Get Cmd line");
	char *cmd;
	char buf[1024];	
	cmd =0;
	FILE *fp;
	char *name;
	int n;
	
	fp = fopen(QCString("/proc/"+QString::number(pid)+"/cmdline"), "r") ;
	if((n=fread(buf, 1, sizeof(buf)-1, fp)) > 0) 
	{
		if(buf[n-1]=='\n')
			buf[--n] = 0;
		name = buf;
		while(n) 
		{
			if(((unsigned char)*name) < ' ')
				*name = ' ';
			name++;
			n--;
		}
		*name = 0;
		if(buf[0])
			cmd = strdup(buf);
	}
	fclose(fp);

	zTaskMan->toLog("ZProcInfoDlg: Add visual component");

	ZScrollPanel *scrollPanel = new ZScrollPanel(myWidget, "ProcInfoDlg", 0, ZSkinService::clsZScrollPanel);
	scrollPanel->resize ( 240, 320 );
	scrollPanel->setVScrollBarMode ( ZScrollPanel::AlwaysOff );

	QFont font ( qApp->font() ); 

	ZLabel * myLabel = new ZLabel ( QString ( zTaskMan->extractExecName(QString(cmd))), scrollPanel );
	myLabel->setAutoResize(true);
	font.setPointSize ( 20 );
	myLabel->setFont(font);
	myLabel->setFixedWidth ( 240 );
	myLabel->setAlignment(Qt::AlignHCenter);
	scrollPanel->addChild( myLabel,0,0 );

	font.setPointSize ( 14 );
	
	int h=22;
	myLabel = new ZLabel ( QString ( "Pid: "+QString::number(pid) ), scrollPanel );
	myLabel->setAutoResize(true);
	myLabel->setFont(font);
	myLabel->setFixedWidth ( 240 ); 
	scrollPanel->addChild( myLabel,2,h );
	h+=myLabel->heightForWidth(240)+4;

	myLabel = new ZLabel ( QString ( "Cmd: "+QString(cmd) ), scrollPanel );
	myLabel->setAutoResize(true);
	myLabel->setFont(font);
	//myLabel->setLeading(14);
	myLabel->setFixedWidth ( 240 ); 
	scrollPanel->addChild( myLabel,2, h );
	h+=myLabel->heightForWidth(240)+4;

	myLabel = new ZLabel ( QString (getVmSize(pid)), scrollPanel );
	myLabel->setAutoResize(true);
	myLabel->setFont(font);
	myLabel->setFixedWidth ( 240 ); 
	scrollPanel->addChild( myLabel,2, h );
	h+=myLabel->heightForWidth(240)+4;
	
	myLabel = new ZLabel ( QString (getState(pid)), scrollPanel );
	myLabel->setAutoResize(true);
	myLabel->setFont(font);
	myLabel->setFixedWidth ( 240 ); 
	scrollPanel->addChild( myLabel,2, h );
	h+=myLabel->heightForWidth(240)+6;
	
	myLabel = new ZLabel ( lng->LNG_LOADLIB, scrollPanel );//"Loaded lib:"
	myLabel->setAutoResize(true);
	myLabel->setFont(font);
	myLabel->setFixedWidth ( 240 ); 
	scrollPanel->addChild( myLabel,2, h );
	h+=myLabel->heightForWidth(240)+2;
	
	ZListBox * usesLib = new ZListBox ( QString ( "%I%M" ), scrollPanel, 0);
	usesLib->setFixedWidth ( 240 );
	usesLib->setFixedHeight( 244-h );	
	font.setPointSize ( 11 );
	//font.setBold ( true );
	usesLib->setItemFont(ZListBox::region2, font, true);
	usesLib->setItemFont(ZListBox::region2, font, false);
	//usesLib->setItemFont (ZListBox::LISTITEM_REGION_C, font, true );
	//usesLib->setItemFont (ZListBox::LISTITEM_REGION_C, font, false );	
	
	zTaskMan->toLog("ZProcInfoDlg: Get loadded lib");
    QFile f("/proc/"+QString::number(pid)+"/maps");
    QString s;
    QString htm="";

    if ( f.open( IO_ReadOnly ) )
    {
        QTextStream t( &f );

        while ( !t.eof() )
		{
            s = t.readLine();
            if ( s.find("/SYSV")==-1 && s.find("/")!=-1)
            {
           		s.remove(0, s.find("/"));
           		s.stripWhiteSpace();
           		if ( htm.find(s)==-1)
           		{ 
           			htm=htm+s+"|";
           			ZListBoxItem* listitem = new ZListBoxItem ( usesLib, "%I%M" );
					listitem->appendSubItem ( 1, QString( s ) , false, NULL );
					usesLib->insertItem ( listitem,-1,true );  
				}
			}
        }

        f.close();
    }
    scrollPanel->addChild( usesLib,0, h );

	setContentWidget ( myWidget );

	ZSoftKey *softKey = new ZSoftKey ( NULL, this, this );
	softKey->setText ( ZSoftKey::LEFT, lng->LNG_OK, ( ZSoftKey::TEXT_PRIORITY ) 0 );
	softKey->setClickedSlot ( ZSoftKey::LEFT, this, SLOT ( accept() ) );
	setCSTWidget ( softKey );
	zTaskMan->toLog("ZProcInfoDlg: End");
}

QString ZProcInfoDlg::getVmSize(int pid)
{
    QFile f("/proc/"+QString::number(pid)+"/status");
    QString s;
    if ( f.open( IO_ReadOnly ) )
    {
        QTextStream t( &f );

        while ( !t.eof() )
		{
            s = t.readLine();
            if ( s.find("VmSize:")>-1)
            {
            	while ( s.find("  ")>-1 )
				{
					s.remove( s.find("  ")+1, 1 );	
				}
           		s.stripWhiteSpace();
           		return s;
			}
        }

        f.close();
    }
    return "VmSize:";
}

QString ZProcInfoDlg::getState(int pid)
{
	QString htm;
    QFile f("/proc/"+QString::number(pid)+"/status");
    QString s;
    if ( f.open( IO_ReadOnly ) )
    {
        QTextStream t( &f );

        while ( !t.eof() )
		{
            s = t.readLine();
            if ( s.find("State:")>-1)
            {
            	while ( s.find("  ")>-1 )
				{
					s.remove( s.find("  "), 1 );	
				}
           		s.stripWhiteSpace();
           		return s;
			}
        }

        f.close();
    }
    return "State:";
}

ZProcInfoDlg::~ZProcInfoDlg()
{

}
