/**********************************************************
kLaunch for E2 v0.1b

Written  by Strelok Vlad Kolerts
5/12/2009
Email: admin@mobsk.org.ua
ICQ: 497123239
***********************************************************/

#include <ZApplication.h>

class QDaemonApp : public ZApplication 
{
  Q_OBJECT
  public:

    QDaemonApp(int argc, char **argv);

   // virtual ~QDaemonApp();
  protected slots:
    virtual void slotShutdown(); 
    virtual void slotQuickQuit();
    //virtual void slotRaise();
};

QDaemonApp::QDaemonApp(int argc, char **argv) : ZApplication(argc, argv) 
{
}

/*QDaemonApp::~QDaemonApp()
{
}*/

void QDaemonApp::slotShutdown()
{
    processEvents();
}
void QDaemonApp::slotQuickQuit()
{
    processEvents();
}/*
void QDaemonApp::slotRaise()
{
    processEvents();
}*/

QDaemonApp* a;

#include <ZKbMainWidget.h>

//#include <stdio.h>
//#include <stdlib.h>
//#include <unistd.h>
//#include <signal.h>

#include <qcopchannel_qws.h>

#include <ZConfig.h>
#include <RES_ICON_Reader.h>
#include <ZKeyDef.h>
#include <AM_LauncherInterface.h>
//#include "ZMsg.h"
#include <SETUP_API.h>
#include <qtimer.h>

#include <KString.h>
#define ILAUNCH_REG "/ezx_user/download/appwrite/am/AmConfig"


//#define USER_REG "/ezx_user/download/appwrite/am/UserRegistry"
//#define SYS_REG "/usr/SYSqtapp/am/SysRegistry"

#define MMC_REG "/mmc/mmca1/.system/java/CardRegistry"
#define PHONE_REG "/ezx_user/download/appwrite/am/InstalledDB"
#define SYS_REG "/usr/data_resource/preloadapps/SysRegistry"

//extern "C" void UTIL_SetSideKeyLock(int);

//#include "QDaemonApp.h"

#include <vector>
#include <qtextstream.h>
#include <qfile.h>

/**#include <AM_RegistryManager.h>
#include <AM_AppObject.h>*/

struct registry_structure
{
	QString id;
	QString name;
	QString icon;
	QString appid;
	QString exec;
};

struct data_struct
{
	QString Id;
	QString Name;
	QPixmap Icon;
	QPixmap BigIcon;
	QString AppId;
	QString Exec;
};
int icon_size,icon_size_b;

class Registry
{
	public:
	Registry(QString openfile, QString path);
	
	int total;
	int error;
	RES_ICON_Reader r;
	std::vector<registry_structure> data;
	QString regfile;
	QString it_path;
	bool search(data_struct &regdata, QString searchid);
	void update();
};

Registry::Registry(QString openfile, QString path)
{
	regfile = openfile;
	it_path = path;
	update();
}

bool Registry::search(data_struct &regdata, QString searchid)
{
	if (error == 1)
		return false;
	for (int a = 0; a < total; a++)
	{
		if (searchid.compare(data[a].id) == 0)
		{
			regdata.Id = data[a].id;
			regdata.Name = data[a].name;
			regdata.AppId = data[a].appid;
			regdata.Exec = data[a].exec;
			if(kGetMime(data[a].icon)!="g" && kGetMime(data[a].icon)!=NULL)
			{
				regdata.BigIcon.convertFromImage(QImage(data[a].icon).smoothScale(icon_size_b, icon_size_b));
				regdata.Icon.convertFromImage(QImage(data[a].icon).smoothScale(icon_size, icon_size));
			}
			else
			{
				regdata.BigIcon.convertFromImage(r.getIcon(data[a].icon).convertToImage().smoothScale(icon_size_b, icon_size_b));
				regdata.Icon.convertFromImage(r.getIcon(data[a].icon).convertToImage().smoothScale(icon_size, icon_size));
			}
			return true;
		}
	}
	return false;
}

void Registry::update()
{
	/**QPixmap pm;
	int type, place;
	QString path, exec;
	registry_structure tmp;
	AM_RegistryManager* rman;
	QList<AM_AppObject>    appList;
	AM_AppObject* pAppObj = NULL;
	
	rman = new AM_RegistryManager();
	rman->getAllAppList ( appList );
	
	total=0;data.clear();
	//qDebug("Start reading registry");
	
	for ( pAppObj = ( AM_AppObject* ) appList.first(); pAppObj != NULL; pAppObj = ( AM_AppObject* ) appList.next() )
	{
		tmp.id=pAppObj->getUid();
		tmp.appid=pAppObj->getAppId().toString();
		tmp.name=pAppObj->getName();
		tmp.icon=pAppObj->getBigIcon();
		
		path=pAppObj->getDirectory();
		type=pAppObj->getAttr();
		if(type==3 || type==5)
			tmp.exec="/usr/SYSjava/kvm -launch "+path.right(5);
		else
		{
			place=pAppObj->getDevice();
			if(place==2)
				tmp.exec="/mmc/mmca1/.system/QTDownLoad/";
			else
			{
				if(type==1)
					tmp.exec="/usr/SYSqtapp/";
				else
					tmp.exec="/ezxlocal/.system/QTDownLoad/";
			}
			exec=pAppObj->getExec();
			tmp.exec+=path+"/"+exec;
		}
		data.push_back(tmp);
		
		//AniIcon=pAppObj->getAnimationIcon().utf8();
		
		//void getBigIcon( QPixmap &icon ) const;
		//void getAnimationIcon( QPixmap &icon ) const;
		
		//qDebug("Id: "+tmp.id);
		//qDebug("AppId: "+tmp.appid);
		//qDebug("Name: "+tmp.name);
		//qDebug("Icon: "+tmp.icon);
		//qDebug("Exec: "+tmp.exec);
		
		total++;
	}*/
	//qDebug("Reading registry finish "+QString::number(total));
	
	QString line, item_path, dir, java, exec;
	registry_structure tmp;
	total = 0;
	data.clear();
	
	QFile file(regfile);
	if( file.open(IO_ReadOnly) )		
	{
		qDebug("Reading "+regfile);
		QTextStream stream( &file );
		while (!stream.eof())
		{
			item_path=it_path;
			line=stream.readLine();
			if (line.left(1)=="[" && line.right(1)=="]")
			{
				tmp.id=line.mid(1, line.length()-2);
			}
			if (! tmp.id.isEmpty())
			{
				if (line.find("AppID")==0)
				{
					tmp.appid=line.mid(9, line.length()-10);
				}
				if (line.find("Name")==0)
				{
					tmp.name=UTF(line.mid(7, line.length()));
				}
				else if (line.find("Directory")==0)
				{
					dir=line.mid(12, line.length());
				}
				else if (line.find("JavaId")==0)
				{
					java=line.mid(9, line.length());
				}
				else if (line.find("BigIcon")==0)
				{
					tmp.icon=line.mid(10, line.length());
				}
				else if (line.find("Exec")==0)
				{
					tmp.exec=line.mid(7, line.length());
				}
				
				if (!tmp.name.isEmpty())
				{
					if(regfile==SYS_REG)
					{
						exec=item_path+dir+"/";
						item_path="";
					}
					else
					{
						if(java=="-1")
						{
							item_path+="QTDownLoad/"+dir+"/";
							exec=item_path;
						}
						else
						{
							exec="/usr/SYSjava/kvm -launch "+java;
							item_path=dir+"/";
						}
					}
					tmp.exec=exec+tmp.exec;
					tmp.icon=item_path+tmp.icon;
					//qDebug(tmp.id+" "+tmp.name+" "+tmp.icon+" "+tmp.exec);
					data.push_back(tmp);
					tmp.id="";
					tmp.appid="";
					tmp.name="";
					tmp.icon="";
					tmp.exec="";
					item_path="";
					java="";
					exec="";
					dir="";
					
					total++;
				}
			}
		}
		file.close();
		qDebug("ok");
	}
	else
	{
		qDebug("Open "+regfile+" failed.");
	}
	if (total == 0)
		error = 1;
	else
		error = 0;
}

QString getKeyNum(int key)
{
	QString numero;
	if ( key == 48 ) numero = "0";		else if ( key == 49 ) numero = "1";
	else if ( key == 50 ) numero = "2";	else if ( key == 51 ) numero = "3";
	else if ( key == 52 ) numero = "4";	else if ( key == 53 ) numero = "5";
	else if ( key == 54 ) numero = "6";	else if ( key == 55 ) numero = "7";
	else if ( key == 56 ) numero = "8";	else if ( key == 57 ) numero = "9";
	else if ( key == 42 ) numero = "*";	else if ( key == 35 ) numero = "#";
	return numero;
}


#include <ZPopup.h>
#include <zTAPI.h>
#include <PHONE_VoiceCallSender.h>

#include <ZNoticeDlg.h>

class zCalls : public ZPopup {
  Q_OBJECT
  public:
	QString num, pImei;
    zCalls();
	void insertText(QString numero);
  public slots:   
    virtual void accept();
    virtual void reject();
  protected:
	virtual void keyPressEvent(QKeyEvent* k);
};

zCalls::zCalls() : ZPopup()
{
	QString Fval1; ZConfig Fini1(QString("/ezxlocal/download/appwrite/setup/ezx_theme.cfg"), true);
	Fval1 = Fini1.readEntry(QString("THEME_GROUP_LOG"), QString("CurrentSkin"), "");
	ZConfig Fini3(Fval1 + "/phone_p.ini", false);
	int TextColor = Fini3.readNumEntry(QString("Font_DialingSmallStd"), QString("Color"), 0);
	//int TextColor=0;

	///num = numero;
	setTitleIcon("call_enter_thb");
	setTitle("Dial");
	QFont font; font.setPixelSize(35);
	setInstructFont(font);
	setInstructFontColor(QRgb(TextColor));
	setSoftkeyText("Call", "Cancel");
	
	connect( this, SIGNAL(leftSoftkeyClicked()), SLOT(accept()) );
	connect( this, SIGNAL(rightSoftkeyClicked()), SLOT(reject()) );
	
	unsigned int res;
	IMEI_ARRAY imei;
	TAPI_CLIENT_Init(0, 0);
	res=TAPI_ACCE_GetImei(imei);     
	if (res == 0)
		pImei=QString::fromLatin1(reinterpret_cast<char*>(imei));
	else
		pImei="Can't get IMEI";
	
	//setInstructText(num);
	qApp->processEvents();
}

void zCalls::insertText(QString numero)
{
	///setInstructText("");
	num = numero;
	setInstructText(num);
}

void zCalls::keyPressEvent(QKeyEvent* k)
{
	if ((k->key()>=48 && k->key()<=57) || k->key()==42 || k->key()==35)
	{
		num+=getKeyNum(k->key());
		setInstructText(num);
		qApp->processEvents();
	}
	else if ( k->key() == 0x1032 ) // C
	{
		if ( num.length() > 0) num.remove( num.length() -1, 1);
		setInstructText(num);
		qApp->processEvents();
		if ( num == "" ) reject();
	}
	
	else if ( k->key() == 0x1031) //	Red
	{
		reject();
	}
	else if ( k->key() == 0x1030) // Green
	{
		accept();
	}

	if (num == "*#06#")
	{
		reject();
		ZNoticeDlg* dlg = new ZNoticeDlg((ZNoticeDlg::Type)1, "Your IMEI:", pImei, NULL, "showNotify", true, 0, false);
		dlg->show();
		///screenx->showIMEI();
	}

	if (num == "*#9999#")
	{
		///screenx->showFLEX();
	}
}
void zCalls::reject()
{
	///screenx->cancelcall();
	setInstructText(" ");
	this->hide();
}
void zCalls::accept()
{
	PHONE_VoiceCallSender pepe;
	pepe.makeCall(num, 0);
	reject();
}


extern "C" int UTIL_GetIdleFocus();
extern "C" int UTIL_GetPhoneInCall();
//extern "C" int UTIL_GetCallConnectedStatus();

#include <kInterface.h>

class kLaunch : public ZKbMainWidget
{
    Q_OBJECT

public:
    kLaunch();
   // ~kLaunch();
	
	QPainter	p;
	QPixmap* 	bg_buf;
	QPixmap 	bg_tmp;
	QPixmap 	w_bg;
	QPixmap 	p_bg;
	
	//QImage		img;
	zCalls* callpad;
	SETUP_API* api;
	
	QString		skin_name;
	QColor		nameCol;
	QColor		bnameCol;
	bool		border;
	int			nameSize;
	int			namePos;
	//QPixmap 	p_icon[10];
	
	QFont	font;
	QTimer*	timer;
	
	QString path;
	bool show_app, delay_out;
	bool transparency_bg, animation, animation1;
	int animation2, key_delay, anim_delay;
	int x, y;
	int it_c, cur_it;
	int click_anim;
	
	int padding_l,padding_r;
	int icon_num;
	int width, height;
	int icon_size_max;
	int icon_step;
	int icon_p,icon_p_b;
	int icon_c,icon_c_b;
	int icon_y,icon_y_b;
	
	/*QStringList Name;
	QStringList Exec;
	QStringList BigIcon;*/
	std::vector<data_struct> data;
	Registry* registry;
	Registry* phonedb;
	Registry* carddb;
	Registry* sysdb;
	//Registry* userdb;
	
	QString		Wallpaper;
	
	void paint(int anim);
	bool left, right, launch;
	
	void run(QString id);
	void mrun();
	
	int run_c;
	bool launch_run;
	
	void delay(int msec);
	
    void readConfig();
	void readSkinCfg();
	void readItemsCfg();
	//void readCfgItem(QString id, QString place, QString item_path);
	
	void keyPressEvent(QKeyEvent *event);
	void keyReleaseEvent(QKeyEvent *event);
	void focusOutEvent(QFocusEvent* event);
	void focusInEvent(QFocusEvent* event);
	
	void sendHardKey(int key);
	
	QCopChannel *cop;
	QCopChannel *cop_desktop;
	QCopChannel *cop_focus;
	
public slots:
	void repaint();
	void showLaunch();
	void hideLaunch();
	void clearBg();
	void refreshBg();
	void keyBoardProcess();
	void slotQCopReceived(const QCString &msg);
};

kLaunch::kLaunch() : 
    ZKbMainWidget(ZHeader::FULL_TYPE, NULL, "ZMainWidget", 0)
	{
		cop_desktop = new QCopChannel("/app/phone/msg/idlestat", this);
		connect(cop_desktop, SIGNAL(received(const QCString&, const QByteArray&)), this, SLOT(slotQCopReceived(const QCString&)));
		
		callpad = new zCalls();
		
		timer = new QTimer(this);
		connect( timer, SIGNAL(timeout()), SLOT(keyBoardProcess()) );
	
		setBackgroundMode(NoBackground);
		
		left=right=launch=launch_run=false;
		show_app=true;
		path=kGetPath(QString(qApp->argv()[0]));
		x=240;
		click_anim=0;
		font=QFont(NULL, 10, 25, false);
		
		//qDebug("Loading registry");
		///registry = new Registry();
		//qDebug("Loading registry ok");
		phonedb = new Registry(PHONE_REG, "/ezxlocal/.system/");
		carddb = new Registry(MMC_REG, "/mmc/mmca1/.system/");
		sysdb = new Registry(SYS_REG, "/usr/SYSqtapp/");
		//userdb = new Registry(USER_REG, 0);
		
		//bg_buf = new QPixmap(240, 60);//
		readConfig();
		
		cop = new QCopChannel("kLaunch", this);
		connect(cop, SIGNAL(received(const QCString&, const QByteArray&)), this, SLOT(slotQCopReceived(const QCString&)));
	}

/*kLaunch::~kLaunch()
	{
	}*/
	
void kLaunch::showLaunch()
{
	x=240;
	paint(0);
	//show();
	show_app=true;
	if(!animation)
		x=0;
	while(x>0)
	{
		x-=40;
		repaint();
		delay(1);
		qApp->processEvents();
	}
}

void kLaunch::hideLaunch()
{
	left=right=false;
	show_app=false;
	if(!animation)
		x=240;
	while(x<240)
	{
		x+=2;
		//delay(1);
		repaint();
		clearBg();
	}
	QTimer::singleShot(200, this, SLOT(hide()));
}

void kLaunch::paint(int anim)
	{
		//QImage img1, img2, img3, img4, img5;
		int x_anim=0, d=1, anim_step=0;
		
		p.setPen(nameCol);
		p.setFont(font);
		
		//QString img_path[5]={BigIcon[(cur_it+it_c-2)%it_c], BigIcon[(cur_it+it_c-1)%it_c], BigIcon[cur_it], BigIcon[(cur_it+1)%it_c], BigIcon[(cur_it+2)%it_c]};
		//RES_ICON_Reader r;
		
		/*if(kGetMime(img_path[0])!="g" && kGetMime(img_path[0])!=NULL)
			img1=QImage(img_path[0]).smoothScale( 34, 34 );
		else
			img1=QImage(r.getIcon(img_path[0]).convertToImage()).smoothScale( 34, 34 );
		if(kGetMime(img_path[1])!="g" && kGetMime(img_path[1])!=NULL)
			img2=QImage(img_path[1]).smoothScale( 34, 34 );
		else
			img2=QImage(r.getIcon(img_path[1]).convertToImage()).smoothScale( 34, 34 );
		if(kGetMime(img_path[2])!="g" && kGetMime(img_path[2])!=NULL)
			img3=QImage(img_path[2]).smoothScale( 48-click_anim, 48-click_anim );
		else
			img3=QImage(r.getIcon(img_path[2]).convertToImage()).smoothScale( 48-click_anim, 48-click_anim );
		if(kGetMime(img_path[3])!="g" && kGetMime(img_path[3])!=NULL)
			img4=QImage(img_path[3]).smoothScale( 34, 34 );
		else
			img4=QImage(r.getIcon(img_path[3]).convertToImage()).smoothScale( 34, 34 );
		if(kGetMime(img_path[4])!="g" && kGetMime(img_path[4])!=NULL)
			img5=QImage(img_path[4]).smoothScale( 34, 34 );
		else
			img5=QImage(r.getIcon(img_path[4]).convertToImage()).smoothScale( 34, 34 );*/
		
		if(anim)
		{
			if(left) {d=-1;}
			if(right) {d=1;}
			anim_step=icon_step/(anim+1);
			x_anim=icon_step-anim_step;
		}
		do
		{
			if(transparency_bg)
			{
				QString wallpaper;
				api->getWallpaper(wallpaper);//
				if(Wallpaper!=wallpaper)
				{
					Wallpaper=wallpaper;
					refreshBg();
				}
			}
				
			p.drawPixmap(0, 0, bg_tmp);
			//bg_buf=bg_tmp;
			
			/**if(right && anim)
				p.drawPixmap((-36)+x_anim*d,12,	data[(cur_it+it_c-3)%it_c].Icon);
			if(left && anim)
				p.drawPixmap(242+x_anim*d,	12,	data[(cur_it+3)%it_c].Icon);
			
			p.drawPixmap(8+x_anim*d,		12,	data[(cur_it+it_c-2)%it_c].Icon);
			p.drawPixmap(52+x_anim*d,		12,	data[(cur_it+it_c-1)%it_c].Icon);
			p.drawPixmap(154+x_anim*d,		12,	data[(cur_it+1)%it_c].Icon);
			p.drawPixmap(198+x_anim*d,		12,	data[(cur_it+2)%it_c].Icon);
			if(!click_anim)
				p.drawPixmap(96+x_anim*d,	2,	data[cur_it].BigIcon);
			else
				p.drawPixmap(96+x_anim*d+5,	2+5,	data[cur_it].Icon);*/
				
			int pos=padding_l-icon_step;	
			if(right && anim)
				p.drawPixmap((pos)+x_anim*d+icon_c,	icon_y+icon_c,	data[(cur_it+it_c-icon_num/2-1)%it_c].Icon);
			pos=padding_l+icon_step*icon_num;
			if(left && anim)
				p.drawPixmap(pos+x_anim*d+icon_c,	icon_y+icon_c,	data[(cur_it+icon_num/2+1)%it_c].Icon);
			
			pos=padding_l;
			for(int i=icon_num/2;i>0;i--)
			{
				p.drawPixmap(pos+x_anim*d+icon_c,		icon_y+icon_c,	data[(cur_it+it_c-i)%it_c].Icon);
				pos+=icon_step;
			}
			if(!click_anim && !anim && !left && !right)
				p.drawPixmap(pos+x_anim*d+icon_c_b,	icon_y+icon_c_b,	data[cur_it].BigIcon);
			else
				p.drawPixmap(pos+x_anim*d+icon_c,	icon_y+icon_c,	data[cur_it].Icon);
			pos+=icon_step;
			for(int i=1;i<=icon_num/2;i++)
			{
				p.drawPixmap(pos+x_anim*d+icon_c,		icon_y+icon_c,	data[(cur_it+i)%it_c].Icon);
				pos+=icon_step;
			}
			
			
			
			//p.begin( bg_buf ,this);
			//p.setFont(font);
			//p.setPen(nameCol);
			//if(!anim)
			if(border)
			{
				p.setPen(bnameCol);
				p.drawText(0, namePos+1, 240, nameSize, Qt::AlignCenter, data[cur_it].Name, -1);
				p.drawText(0, namePos-1, 240, nameSize, Qt::AlignCenter, data[cur_it].Name, -1);
				p.drawText(1, namePos, 240, nameSize, Qt::AlignCenter, data[cur_it].Name, -1);
				p.drawText(-1, namePos, 240, nameSize, Qt::AlignCenter, data[cur_it].Name, -1);
			}
			p.setPen(nameCol);
			p.drawText(0, namePos, 240, nameSize, Qt::AlignCenter, data[cur_it].Name, -1);
			//p.end();
			//QTimer::singleShot(100, this, SLOT(repaint()));
			repaint();
			anim--;
			if(anim<=0)
				x_anim=0;
			else
				x_anim=x_anim-anim_step;
			delay(anim_delay);
		}
		while(anim>=0);
	}

void kLaunch::repaint()
	{
		bitBlt( this, x, 0, bg_buf );
		//qDebug(QString("kLaunch::repaint x:%1").arg(240-x));
	}

void kLaunch::delay(int msec)
{
	struct timespec elapsed, tv;
	elapsed.tv_sec = msec/1000;
	elapsed.tv_nsec = (msec%1000)*1000000;
	tv.tv_sec = elapsed.tv_sec;
	tv.tv_nsec = elapsed.tv_nsec;
	nanosleep(&tv, &elapsed);
}

void kLaunch::keyBoardProcess()
{
	qApp->processEvents();
	
	if(UTIL_GetPhoneInCall())
		hide();
	
	if(left)	cur_it=(cur_it+it_c-1)%it_c;
	if(right)	cur_it=(++cur_it)%it_c;
	
	mrun();
	
	if(left||right)
	{
		paint(animation2);
		ZConfig kcfg(path+"/kLaunch.cfg", true);
		kcfg.writeEntry("Setting", "CurrentItem", cur_it);
	}
}

///#include <ZPhoneCall.h>
///#include "zCallDlg.h"

void kLaunch::keyPressEvent(QKeyEvent *k)
	{
		//printf("KEY: %x\n", k->key());
		switch (k->key())
		{
			case 0x1004: //	Center
				if(!launch && !launch_run)
				{
					launch=true;
					run_c=10;
					if(animation1)
					{
						click_anim=10;
						paint(0);
						click_anim=0;
					}
				}
			break;
			
			case 0x1014: //	Right
				right=true;
			break;
			case 0x1012: //	Left
				left=true;
			break;
			
			case 0x1031: //	Red
				hideLaunch();
			break;
			
			case 0x1030: // Green
				run("ce59717d-fb23-4b7c-8800-25ce613f4042");
			break;
			
			case 0x103a: //	RightSoft
				if (QCopChannel::isRegistered("kMMenu"))
					//system(path+"qcop_send kMMenu switch");
					QCopChannel::send("kMMenu", "switch");
				else
					//system(path+"/qcop_send AM_MainMenuChannel SHOWMAINMENU");
					QCopChannel::send("AM_MainMenuChannel", "SHOWMAINMENU");
			break;
			
			case 4172: // Key Next
				if(QCopChannel::isRegistered("SVKPlayer"))
					QCopChannel::send("SVKPlayer", "next");
				else
					UTIL_BroadcastKeyMsg(4172, 1);
			break;
			case 4171: //	Key Prew
				if(QCopChannel::isRegistered("SVKPlayer"))
					QCopChannel::send("SVKPlayer", "prew");
				else
					UTIL_BroadcastKeyMsg(4171, 1);
			break;
			case 4169: //	Key Play
				if(QCopChannel::isRegistered("SVKPlayer"))
					QCopChannel::send("SVKPlayer", "show");
				else
					UTIL_BroadcastKeyMsg(4169, 1);
			break;

			/*case 48:
				if (QCopChannel::isRegistered("VR/Dialpad"))
				{
					qDebug("VR Command Open Digits Dial");
					QCopChannel::send("VR/Dialpad", "VR Command Open Digits Dial");
				}
			break;
			
			case 49:
				if (QCopChannel::isRegistered("VR/Dialpad"))
				{
					qDebug("VR Show Digit String(QString)");
					QByteArray data;
					QDataStream stream(data, IO_WriteOnly);
					stream << QString("1");
					QCopChannel::send("VR/Dialpad", "VR Show Digit String(QString)", data);
				}
			break;*/
			
			case 35:
				readConfig();
				//readSkinCfg();
			break;
			
			/**case 48:
				if(1)
				{
					ZPhoneCall* call = new ZPhoneCall(this, "");
					qDebug(QString(call->makeVoiceCall(QString("*111#")) ? "ok" : "false"));
				}
			break;*/
			
			case 0x1016: //	VolumeUp
				system("/usr/SYSqtapp/systemsetup/setupprofile&");
				//UTIL_SetSideKeyLock(0);
			break;
			case 0x1017: //	VolumeDown
				system("/usr/SYSqtapp/systemsetup/setupprofile&");
				//UTIL_SetSideKeyLock(1);
			break;
			
			default:
				if ((k->key()>=48 && k->key()<=57) || k->key()==42 || k->key()==35)
				{
					callpad->insertText(getKeyNum(k->key()));
					callpad->show();
				}
				/*
				ZPopup * callpad = new ZPopup();
				callpad->exec();*/
			break;
		}
	}
	
void kLaunch::keyReleaseEvent(QKeyEvent *k)
	{
		switch (k->key())
		{
			case 0x1004:
				//qDebug(Exec[cur_it]+"&");
				if(launch)
				{
					if(animation1)
						paint(0);
					//system(data[cur_it].Exec+"&");
					run(data[cur_it].AppId);
					
					launch=false;
				}
				launch_run=false;
				run_c=0;
				paint(0);
			break;
			
			case 0x1014: //	Right
				right=false;
				paint(0);
			break;
			case 0x1012: //	Left
				left=false;
				paint(0);
			break;
			
			default:
			break;
		}
	}
	
void kLaunch::run(QString id)
{
	//qDebug("Run id:"+id);
	QString run="{"+id+"}";
	AM_LauncherInterface::launchApp((QUuid)run,false);
	/*ZMsg msg( "/AM/Launcher", "launchApp4NoLockCheck" );//launchAppWithArgs
	msg << (QUuid)run;
	msg.send();*/
}

void kLaunch::mrun()
{
	if(launch)
	{
		if(run_c<=0)
		{
			paint(0);
			//qDebug(data[cur_it].Exec);
			system(data[cur_it].Exec+"&");
			///sysexec sc;
			///QString run=data[cur_it].Exec;
			///sc.exec(run);
			launch=false;
			launch_run=true;
			paint(0);
		}
		else
			run_c--;
	}
	else
		run_c=0;
}
	
void kLaunch::readConfig()
	{
		ZConfig conf(path+"/kLaunch.cfg", true);
		
		cur_it=atoi(conf.readEntry("Setting",		"CurrentItem",			"0"));
		key_delay=atoi(conf.readEntry("Setting",	"KeyDelay",				"100"));
		
		skin_name="skin/"+conf.readEntry("Setting",	"Skin",	"");
		readSkinCfg();
		
		readItemsCfg();
		
		if(cur_it>=it_c)
			cur_it=it_c-1;
	}

void kLaunch::readSkinCfg()
	{
		ZConfig cfg(path+skin_name+"/skin.ini", true);
		
		transparency_bg=cfg.readBoolEntry("Setting","TransparencyBg",	false);
		animation=cfg.readBoolEntry("Setting",		"AnimationSliderOn",false);
		animation1=cfg.readBoolEntry("Setting",		"AnimationClickOn",	false);
		animation2=cfg.readNumEntry("Setting",		"AnimationMoveIcons",0);
		anim_delay=cfg.readNumEntry("Setting",		"AnimationDelay",	0);
		
		padding_l=cfg.readNumEntry("Geometry",		"LeftPadding",		5);
		padding_r=cfg.readNumEntry("Geometry",		"RightPadding",		5);
		y=cfg.readNumEntry("Geometry",				"PosY",				90);
		
		namePos=cfg.readNumEntry("Name",			"PosY",				48);
		nameSize=cfg.readNumEntry("Name",			"FontSize",			11);
		border=cfg.readBoolEntry("Name",			"EnableBorder",		false);
		nameCol=QColor(cfg.readEntry("Name",		"FontColor",		"#ffffff"));
		bnameCol=QColor(cfg.readEntry("Name",		"BorderColor",		"#000000"));
		
		icon_num=cfg.readNumEntry("Icons",			"Num",				5);
		icon_y=cfg.readNumEntry("Icons",			"PosY",				5);
		icon_size_max=cfg.readNumEntry("Icons",		"MaxSize",			60);
		icon_p=cfg.readNumEntry("Icons",			"SizePercent",		70);
		icon_p_b=cfg.readNumEntry("Icons",			"BigSizePercent",	100);
		
		if(icon_num%2==0)icon_num-=1;
		if(icon_num<3)icon_num=3;
		width=240-padding_l-padding_r;
		icon_step=width/icon_num;
		if(icon_step<icon_size_max)
			icon_size_max=icon_step;
		icon_size=icon_size_max*icon_p/100;
		icon_size_b=icon_size_max*icon_p_b/100;
		icon_c=(icon_size_max-icon_size)/2;
		icon_c_b=(icon_size_max-icon_size_b)/2;
		
		api=new SETUP_API();//
		api->getWallpaper(Wallpaper);//
		w_bg.load(Wallpaper);
		p_bg.load(path+skin_name+"/bg.png");
		
		font.setPixelSize(nameSize);
		
		int w=p_bg.width();int h=p_bg.height();
		if(w==0)w=240;if(h==0)h=60;
		p.end();
		bg_buf = new QPixmap(w, h);
		bg_tmp = QPixmap(w, h);
		
		setFullScreenMode(w, h);
		resize(w, h);
		move(0, y);
		
		p.begin( bg_buf ,this);
		refreshBg();
		QTimer::singleShot(100, this, SLOT(showLaunch()));
	}
	
void kLaunch::readItemsCfg()
	{
		int i=0;it_c=0;
		QStringList ItemsList;QString items;
		ZConfig kcfg(ILAUNCH_REG, true);
		//system("cat "+ILAUNCH_REG);
		items=kcfg.readEntry("ILaunch", "Items", "");
		while(i!=-1)
		{
			/*i = items.findRev(";");
			if(i!=items.length()-1)
			{
				ItemsList.append(items.right(items.length()-i-1));
			}
			items.remove(i, items.length()-i);*/
			i = items.find(";");
			if(i!=1)
			{
				ItemsList.append(items.left(i));
			}
			items.remove(0, i+1);
		}
		
		data.clear();
		
		/*QString places[3]={MMC_REG, PHONE_REG, SYS_REG};
		QString ipath[3]={"/mmc/mmca1/.system/", "/ezxlocal/.system/", "/usr/SYSqtapp/"};*/
		
		for(int index=0; index<(int)ItemsList.count(); index++)
		{
			data_struct tmp;
			if(/**registry->search(tmp, ItemsList[index])*/phonedb->search(tmp, ItemsList[index]) || carddb->search(tmp, ItemsList[index]) || sysdb->search(tmp, ItemsList[index]))
			{
				data.push_back(tmp);
				//qDebug(QString("Id:%1 ").arg(it_c)+"itemName:"+data[it_c].Name+" itemExec:"+data[it_c].Exec/*+" BigIcon:"+tempIcon*/);
				it_c++;
			}
			
			/*QString place="", id="", item_path="";
			bool finded=false;
			
			id=ItemsList[index];
			
			int j=0;
			while(j<3&&!finded)
			{
				ZConfig pcfg(places[j], true);
				if(pcfg.groupExists(id))
				{
					place=places[j];
					item_path=ipath[j];
					finded=true;
				}
				j++;
			}
			if(finded)
				readCfgItem(id, place, item_path);*/
		}
	}

void kLaunch::refreshBg()
{
	QPainter bg;
	w_bg.load(Wallpaper);
	bg.begin(&bg_tmp, this);
	bg.drawPixmap(0, -y, w_bg);
	bg.drawPixmap(0, 0, p_bg);
	bg.end();
	//qDebug("refreshBg");
}

void kLaunch::clearBg()
{
	hide();
	QTimer::singleShot(100, this, SLOT(show()));
}

void kLaunch::focusOutEvent(QFocusEvent *)
{
	delete cop_focus;
	cop_focus=NULL;
	//qDebug("kLaunch::focus out");
	//hide();
	//show_app=false;
	left=right=false;
	launch=false;
	timer->stop();
}

void kLaunch::focusInEvent(QFocusEvent *)
{
	//qDebug("kLaunch::in focus");
	timer->start(key_delay);
	QTimer::singleShot(100, this, SLOT(repaint()));
	
	cop_focus = new QCopChannel("kLaunchInFocus", this);
}
	
void kLaunch::slotQCopReceived(const QCString &msg)
{
	//qDebug("kMMenu::reseive mes"+msg);
	//if(!show_app)	showMenu();
	//else			hideMenu();
	if(msg=="switch")
		{show();a->slotRaise();showLaunch();}
	if(msg=="update")
		{show();readConfig();paint(0);}
		
	if(msg=="idleScrFocusStatMsg")
	{
		if(UTIL_GetIdleFocus() && show_app && !UTIL_GetPhoneInCall())
		{
			show();
			a->slotRaise();
			repaint();
			//show();
			timer->start(key_delay);
		}
	}
}

#include <ZNoticeDlg.h>
bool payChek()
{
	QCString chan = kActChan();
	
	if(QCopChannel::isRegistered(chan))
		return true;
	else
		return false;
}

int main(int argc, char **argv)
{
	QDaemonApp app(argc, argv);
	if (QCopChannel::isRegistered("kLaunch"))
	{
		QCopChannel::send("kLaunch", "switch");
		//qDebug("kLaunch::send mes");
	}
	else
	{
		a = new QDaemonApp(argc, argv);
		
		if(payChek())
		{
			kLaunch* dlg = new kLaunch();
			a->setMainWidget(dlg);
			dlg->hide();
			a->exec();
		}
		else
		{
			ZNoticeDlg* dlg = new ZNoticeDlg((ZNoticeDlg::Type)0, QString("kLaunch::Error"), QString("Please run kActivator before starting..\nMore info at http://e2.at.ua"), NULL, "Error", true, 0, false);
			a->setMainWidget(dlg);
			dlg->show();
			a->exec();
		}
	}
	return 0;
}


#include "kLaunch.moc"
