/**********************************************************
kMMenu for E2 v0.1b

Written  by Strelok Vlad Kolerts
5/12/2009
Email: admin@mobsk.org.ua
ICQ: 497123239
***********************************************************/
#include "kMenuWidget.h"
#include "QDaemonApp.h"
///#include <AM_LauncherInterface.h>
#include "ZMsg.h"
//#include "exec.h"

#include <sys/ioctl.h>
#include <fcntl.h>
#include <linux/power_ic.h>

extern QDaemonApp* a;

extern Registry* phonedb;
extern Registry* carddb;

extern QString UTF( const char*ChineseString );

//extern void Debug( QString print );

extern QString path, skin_name;

extern QString lng_week, lng_month;
extern QString lng_Options, lng_Back;

extern void readMainConfig();

extern "C" int UTIL_GetBatteryLevel();
extern "C" int UTIL_GetSignalQuality();
extern "C" int UTIL_GetChargeStatus();
extern "C" int UTIL_GetBtStatus();
extern "C" int UTIL_GetBtConnCount();

extern "C" int UTIL_GetGprsActivatedStatus();
extern "C" int UTIL_GetGprsAttachStatus();

///extern "C" int UTIL_GetEgprsServiceStatus();
///extern "C" int UTIL_GetEgprsTransStatus();

/**UTIL_GetKeypadLockStatus                 // FUNC
UTIL_GetLanOpenLayout            // FUNC
UTIL_GetLowBatteryStatus                 // FUNC*/


kMenuWidget::kMenuWidget(QString cfg) : 
    ZKbMainWidget(ZHeader::FULL_TYPE, NULL, "ZMainWidget", 0)
	{
		cop_am = new QCopChannel("AM_MainMenuChannel", this);
		connect(cop_am, SIGNAL(received(const QCString&, const QByteArray&)), this, SLOT(slotQCopReceived(const QCString&, const QByteArray&)));
		cop_am_reg = new QCopChannel("AM/RegistryiMgr/Channel", this);
		connect(cop_am_reg, SIGNAL(received(const QCString&, const QByteArray&)), this, SLOT(slotQCopReceived(const QCString&, const QByteArray&)));

		qApp->installEventFilter( this );

		cfg_name=cfg;
		show_app=true;focus=true;
		tmp_signal=tmp_bat=tmp_bt=tmp_gprs=tmp_h=tmp_m=tmp_s=tmp_d=tmp_mo=tmp_y=-9;
		
		setBackgroundMode(NoBackground);
		//setFullScreenMode(240, 320);
		//resize(240, 320);
		//move(0, 0);
		
		QPixmapCache::setCacheLimit(4096);
		
		Signal.icon=QPixmap(1,1);
		Bat.icon=QPixmap(1,1);
		Bt.icon=QPixmap(1,1);
		Gprs.icon=QPixmap(1,1);
		BatCharge=QPixmap(1,1);
		
		bg_buf = new QPixmap(240, 320);
		p.begin( bg_buf ,this);
		
		//qDebug("0");
		iconGrid = new kIconGrid(cfg_name);
		//qDebug("1");
		iconGrid->readMainMenu();
		//qDebug("2");
		
		if(Item.enable)/// Active Item
			Item.text=iconGrid->activeItem();
		if(Path.enable)/// Active Path
			Path.text=iconGrid->activePath();

		readConfig(cfg_name);

		connect( iconGrid, SIGNAL(updateActiveItem()), this, SLOT(updateActiveItem()));
		connect( iconGrid, SIGNAL(updateActivePath()), this, SLOT(updateActivePath()));
		
		connect( iconGrid, SIGNAL(changeSoftKeysName(QString, QString)), this, SLOT(changeSoftKeysName(QString, QString)));
		
		timer = new QTimer(this);
		connect( timer, SIGNAL(timeout()), SLOT(MainProcess()) );
		connect( a, SIGNAL(signalRaise()), this, SLOT(showMenu()) );
		connect( a, SIGNAL(signalRaise()), this, SLOT(showMenu()) );
		//connect( a, SIGNAL(signalRaise()), this, SLOT(showMenu()) );
		//connect( qApp, SIGNAL(signalRaise()), this, SLOT(showMenu()) );
		connect( iconGrid, SIGNAL(changeFocus(bool)), this, SLOT(changeFocus(bool)) );
		connect( iconGrid, SIGNAL(fullHide()), this, SLOT(hideMenu()) );
		
		//QTimer::singleShot(10, this, SLOT(showMenu()));
		
		cop = new QCopChannel("kMMenu", this);
		connect(cop, SIGNAL(received(const QCString&, const QByteArray&)), this, SLOT(slotQCopReceived(const QCString&, const QByteArray&)));
	}
/*
kMenuWidget::~kMenuWidget()
	{
	}*/
void kMenuWidget::loadPic(QPixmap &pic, QString way)
{
	if(!QPixmapCache::find(way, pic))
	{
		pic.load(way);
		QPixmapCache::insert(way, pic);
	}
}
	
void kMenuWidget::MainProcess()
{
	int signal_level=0;int bat_level=0;int charger=0; int bt_stat=0; int gprs_stat=0;
	if(!iconGrid->inFocus && show_app)
		QTimer::singleShot(100, iconGrid, SLOT(showMenu()));
		
/// Signal Level
	if(Signal.enable)
	{
		signal_level=UTIL_GetSignalQuality();
		if(tmp_signal!=signal_level)
		{
			tmp_signal=signal_level;
			//Signal.icon.load(path+skin_name+Signal.line.arg(signal_level));
			loadPic(Signal.icon, path+skin_name+Signal.line.arg(signal_level));
		}
	}
	
/// Battery Level
	if(Bat.enable)
	{
		charger=UTIL_GetChargeStatus();
		bat_level=UTIL_GetBatteryLevel();
		if(charger && charge!=charger)
			timer->start(charge_delay);
		if(!charger && charge!=charger)
		{
			if(focus)
				timer->start(infocus_delay);
			else
				timer->start(outfocus_delay);
		}
		charge=charger;
		if(bat_level==1)					bat_level=0;
		if(bat_level==2 || bat_level==3)	bat_level=1;
		if(bat_level==4)					bat_level=2;
		if(bat_level==5)					bat_level=3;
		
		if(charger && bat_level<3)
		{
			if(charge_type==1)
			{
				ch=(++ch) % (bat_level+1);
				bat_level=ch;
			}
			else if(charge_type==2 || charge_type==3)
			{
				ch=!ch;
				loadPic(BatCharge, path+skin_name+Bat.line.arg("charge"));
			}
			else
			{
				ch=!ch;
				if(!ch)
					bat_level=ch;
			}
		}
		else
			ch=0;
		
		if(tmp_bat!=bat_level)
		{
			tmp_bat=bat_level;
			//Bat.icon.load(path+skin_name+Bat.line.arg(bat_level));
			loadPic(Bat.icon, path+skin_name+Bat.line.arg(bat_level));
		}
	}

///BT Status
	if(Bt.enable)
	{
		bool bt_connect_stat=UTIL_GetBtConnCount();
		bt_stat=UTIL_GetBtStatus();// 0 - off, 1 - on, 2 - search
		if(bt_stat>1)
		{
			bt_stat=bt_search;
			bt_search=!bt_search;
		}
		else
			bt_search=0;
		bt_stat+=bt_connect_stat;
		if(tmp_bt!=bt_stat)
		{
			tmp_bt=bt_stat;
			//Bt.icon.load(path+skin_name+Bt.line.arg(bt_stat));
			loadPic(Bt.icon, path+skin_name+Bt.line.arg(bt_stat));
		}
	}
	
///GPRS Status
	if(Gprs.enable)
	{
		gprs_stat=UTIL_GetGprsAttachStatus()+UTIL_GetGprsActivatedStatus();//UTIL_GetGprsActivatedStatus();
		if(tmp_gprs!=gprs_stat)
		{
			tmp_gprs=gprs_stat;
			//Gprs.icon.load(path+skin_name+Gprs.line.arg(gprs_stat));
			loadPic(Gprs.icon, path+skin_name+Gprs.line.arg(gprs_stat));
		}
	}
	
///	Time
	if(Time.enable)
	{
		QString ampm, mm, ss;
		QDateTime date_time;
		QTime time=date_time.currentDateTime().time();
		int h=time.hour();
		int m=time.minute();
		int s=time.second();
		if(tmp_h!=h || tmp_m!=m || tmp_s!=s)
		{
			tmp_h=h;tmp_m=m;tmp_s=s;
			
			int hh=h;
			if(m<10)	mm=QString("0%1").arg(m);	else mm=QString("%1").arg(m);
			if(s<10)	ss=QString("0%1").arg(s);	else ss=QString("%1").arg(s);

			if(hh<=12)
				ampm="am";
			else
			{
				hh=hh-12;
				ampm="pm";
			}
			if(hh==0)
				ampm="pm";
				
			// %h - hour(int), %m - min(int), %s - sec(int), %H - hour12(int), %i - ampm(str)
			int i=0;int len=strlen(Time.line);
			QString tmp;
			Time.text="";
			while(i<len)
			{
				tmp=Time.line.mid(i,1);
				if(tmp!="%")
					Time.text+=tmp;
				else
				{
					i++;
					tmp=Time.line.mid(i,1);
					if(tmp=="h")
						Time.text+=QString::number(h);
					else if(tmp=="m")
						Time.text+=mm;
					else if(tmp=="s")
						Time.text+=ss;
					else if(tmp=="H")
						Time.text+=QString::number(hh);
					else if(tmp=="i")
						Time.text+=ampm;
					else 
						Time.text+="%"+tmp;
				}
				i++;
			}
		}
	}
	
///	Date
	if(Date.enable)
	{
		QDateTime date_time;
		QDate date=date_time.currentDateTime().date();
		int w=date.dayOfWeek();
		int d=date.day();
		int m=date.month();
		int y=date.year();
		if(tmp_d!=d || tmp_mo!=m || tmp_y!=y)
		{
			tmp_d=d; tmp_mo=m; tmp_y=y;
			// %d - day(int), %m - month(int), %y - year(int), %w - day of week(str), %M - month(str), %c - month cut(str)
			int i=0;int len=strlen(Date.line);
			QString tmp;
			Date.text="";			
			while(i<len)
			{
				tmp=Date.line.mid(i,1);
				if(tmp!="%")
					Date.text+=tmp;
				else
				{
					i++;
					tmp=Date.line.mid(i,1);
					if(tmp=="d")
						Date.text+=QString::number(d);
					else if(tmp=="m")
						Date.text+=QString::number(m);
					else if(tmp=="y")
						Date.text+=QString::number(y);
					else if(tmp=="w")
						Date.text+=week[w-1];
					else if(tmp=="M")
						Date.text+=month[m-1];
					else if(tmp=="c")
						Date.text+=month[m-1].left(3);
					else 
						Date.text+="%"+tmp;
				}
				i++;
			}
		}
	}
/*	
/// Active Item
	if(Item.enable)
	{
		Item.text=iconGrid->activeItem();
	}

/// Active Path
	if(Path.enable)
	{
		Path.text=iconGrid->activePath();
	}
*/	
/// CPU
	if(Cpu.enable)
	{
		QFile cpufile("/proc/cpuinfo");
		if ( cpufile.open( IO_ReadOnly ) ) 
		 {
		QTextStream stream( &cpufile );
		stream.readLine();
		Cpu.text = stream.readLine();
		cpufile.close();
		}
		Cpu.text=Cpu.text.right(6);
		if(cpu_round)
			Cpu.text=Cpu.text.left(3);
		Cpu.text=Cpu.line.arg(Cpu.text);
	}

/// Battery volume
	if(BatVol.enable)
	{
		BAT_INFO bat_info;
		bat_info.time = 0;
		int fb = open("/dev/power_ic", O_RDWR);
		if (fb)
		{
			ioctl (fb,POWER_IC_IOCTL_ATOD_BATT_AND_CURR,&bat_info);
			BatVol.text=BatVol.line.arg(bat_info.bat);
		}
	}

///
	paint();
}

void kMenuWidget::updateActiveItem()
{
	if(Item.enable)
	{
		Item.text=iconGrid->activeItem();
		/*p.setPen(bgColor);
		p.fillRect(Item.x, Item.y, Item.w, Item.h, QBrush(bgColor));
		p.setPen(itemCol);
		p.setFont(itemFont);
		p.drawText(Item.x, Item.y, Item.w, Item.h, Qt::AlignHCenter|Qt::AlignVCenter, Item.text, -1);
		repaint();*/
		paint();
	}
}
void kMenuWidget::updateActivePath()
{
	if(Path.enable)
	{
		Path.text=iconGrid->activePath();
		/*p.setPen(bgColor);
		p.fillRect(Path.x, Path.y, Path.w, Path.h, QBrush(bgColor));
		p.setPen(pathCol);
		p.setFont(pathFont);
		p.drawText(Path.x, Path.y, Path.w, Path.h, Qt::AlignHCenter|Qt::AlignVCenter, Path.text, -1);
		repaint();*/
		paint();
	}
}

void kMenuWidget::paint()
{
	bg_buf->fill(bgColor);
	
/// Signal Level
	if(Signal.enable)
	{
		p.drawPixmap(Signal.x, Signal.y, Signal.icon);
	}
	
/// Battery Level
	if(Bat.enable)
	{
		p.drawPixmap(Bat.x, Bat.y, Bat.icon);
		if(((charge_type==2 && ch) || charge_type==3) && charge)
			p.drawPixmap(Bat.x, Bat.y, BatCharge);
	}

/// BT Status
	if(Bt.enable)
	{
		p.drawPixmap(Bt.x, Bt.y, Bt.icon);
	}
	
/// GPRS Status
	if(Gprs.enable)
	{
		p.drawPixmap(Gprs.x, Gprs.y, Gprs.icon);
	}

/// Time
	if(Time.enable)
	{
		p.setPen(Time.color);
		p.setFont(Time.font);
		p.drawText(Time.x, Time.y, Time.w, Time.h, Qt::AlignHCenter|Qt::AlignVCenter, Time.text, -1);
	}
	
/// Date
	if(Date.enable)
	{
		p.setPen(Date.color);
		p.setFont(Date.font);
		p.drawText(Date.x, Date.y, Date.w, Date.h, Qt::AlignHCenter|Qt::AlignVCenter, Date.text, -1);
	}

/// Active Item
	if(Item.enable)
	{
		p.setPen(Item.color);
		p.setFont(Item.font);
		p.drawText(Item.x, Item.y, Item.w, Item.h, Qt::AlignHCenter|Qt::AlignVCenter, Item.text, -1);
	}

/// Active Path
	if(Path.enable)
	{
		p.setPen(Path.color);
		p.setFont(Path.font);
		p.drawText(Path.x, Path.y, Path.w, Path.h, Qt::AlignHCenter|Qt::AlignVCenter, Path.text, -1);
	}

/// CPU
	if(Cpu.enable)
	{
		p.setPen(Cpu.color);
		p.setFont(Cpu.font);
		p.drawText(Cpu.x, Cpu.y, Cpu.w, Cpu.h, Qt::AlignHCenter|Qt::AlignVCenter, Cpu.text, -1);
	}
	
/// Battery Volume
	if(BatVol.enable)
	{
		p.setPen(BatVol.color);
		p.setFont(BatVol.font);
		p.drawText(BatVol.x, BatVol.y, BatVol.w, BatVol.h, Qt::AlignHCenter|Qt::AlignVCenter, BatVol.text, -1);
	}
	
///SoftKeys
	p.setPen(softColor);
	p.setFont(softFont);
	p.drawText(0, 304-(320-height), 120, 16, Qt::AlignHCenter|Qt::AlignVCenter, leftSoft, -1);
	p.drawText(120, 304-(320-height), 120, 16, Qt::AlignHCenter|Qt::AlignVCenter, rightSoft, -1);
	
	repaint();
}
	
void kMenuWidget::showMenu()
{
	paint();
	show();
	a->slotRaise();
	timer->start(infocus_delay);
	QTimer::singleShot(50, this, SLOT(repaint()));
}

void kMenuWidget::hideMenu()
{
	timer->stop();
	hide();
}
void kMenuWidget::set_paints()
{
}

void kMenuWidget::repaint()
{
	bitBlt( this, 0, 0, bg_buf );
}

void kMenuWidget::changeFocus(bool focusIconGrid)
{
	if(focusIconGrid)
		focusIn();
	else
		focusOut();
}

void kMenuWidget::focusIn()
{
	qDebug("focus in");
	focus=true;
	MainProcess();
	if(!charge)
		timer->start(infocus_delay);
	else
		timer->start(charge_delay);
}
	
void kMenuWidget::focusOut()
{
	qDebug("focus out");
	focus=false;
	if(!charge)
	{
		if(outfocus_delay>0)
			timer->start(outfocus_delay);
		else
			timer->stop();
	}
}

void kMenuWidget::focusInEvent(QFocusEvent * )
{
	//Debug("MainWidget in focus");
	show_app=true;
	//if(focus)
		QTimer::singleShot(200, iconGrid, SLOT(showMenu()));
	//this->hide();
}

void kMenuWidget::focusOutEvent(QFocusEvent * )
{
	show_app=false;
}

void kMenuWidget::changeSoftKeysName(QString left_soft, QString right_soft)
{
	//qDebug("change softkeys to "+left_soft+" & "+right_soft);
	leftSoft=left_soft;
	rightSoft=right_soft;
	paint();
}

void kMenuWidget::readConfig(QString cfg_name)
{
	//QString col="";
	int size=0;
	QPixmapCache::clear();
	
	ZConfig cfg(path+skin_name+QString("/%1_indicators.ini").arg(cfg_name), true);
	
///	Setting
	
	width=atoi(cfg.readEntry("_Setting",  "Width", "240"));
	height=atoi(cfg.readEntry("_Setting",  "Height", "320"));

	bgColor=cfg.readEntry("_Setting",  "BgColor", "#000000");
	softColor=cfg.readEntry("_Setting",  "SoftKeyFontColor", "#ffffff");

	size=atoi(cfg.readEntry("_Setting",  "SoftKeyFontSize", "11"));
	softFont=QFont(NULL, size, 25, false);
	//softFont.setPixelSize(softSize);

	infocus_delay=atoi(cfg.readEntry("_UpdateDelay",	"InFocusDelay", "1000"));
	outfocus_delay=atoi(cfg.readEntry("_UpdateDelay",	"OutFocusDelay", "1000"));
	charge_delay=atoi(cfg.readEntry("_UpdateDelay",		"ChargeDelay", "1000"));
	
	if(infocus_delay<100)infocus_delay=100;
	if(charge_delay<100)charge_delay=100;
	charge=UTIL_GetChargeStatus();
	ch=0;
	
/// Signal Level
	Signal.enable=atoi(cfg.readEntry("SignalLevelIcon",  "Enable", "0"));
	if(Signal.enable)
	{
		Signal.x=atoi(cfg.readEntry("SignalLevelIcon",  "PosX", "0"));
		Signal.y=atoi(cfg.readEntry("SignalLevelIcon",  "PosY", "0"));
		Signal.line=cfg.readEntry("SignalLevelIcon",	"IconPath", "/indicators/signal/%1.png");
	}
	
/// Battery Level
	Bat.enable=atoi(cfg.readEntry("BatteryLevelIcon",  "Enable", "0"));
	if(Bat.enable)
	{
		Bat.x=atoi(cfg.readEntry("BatteryLevelIcon",	"PosX", "0"));
		Bat.y=atoi(cfg.readEntry("BatteryLevelIcon",	"PosY", "0"));
		Bat.line=cfg.readEntry("BatteryLevelIcon",		"IconPath", "/indicators/battery/%1.png");
		charge_type=atoi(cfg.readEntry("BatteryLevelIcon",	"ChargeAnimationType", "0"));
	}

/// BT Status
	Bt.enable=atoi(cfg.readEntry("BtStatusIcon",  "Enable", "0"));
	if(Bt.enable)
	{
		Bt.x=atoi(cfg.readEntry("BtStatusIcon",	"PosX", "0"));
		Bt.y=atoi(cfg.readEntry("BtStatusIcon",	"PosY", "0"));
		Bt.line=cfg.readEntry("BtStatusIcon",	"IconPath", "/indicators/bt/%1.png");
	}

/// GPRS Status
	Gprs.enable=atoi(cfg.readEntry("GprsStatusIcon",  "Enable", "0"));
	if(Gprs.enable)
	{
		Gprs.x=atoi(cfg.readEntry("GprsStatusIcon",	"PosX", "0"));
		Gprs.y=atoi(cfg.readEntry("GprsStatusIcon",	"PosY", "0"));
		Gprs.line=cfg.readEntry("GprsStatusIcon",		"IconPath", "/indicators/gprs/%1.png");
	}

/// Time
	Time.enable=atoi(cfg.readEntry("TimeText",  "Enable", "0"));
	if(Time.enable)
	{
		Time.x=atoi(cfg.readEntry("TimeText",	"PosX", "0"));
		Time.y=atoi(cfg.readEntry("TimeText",	"PosY", "0"));
		Time.w=atoi(cfg.readEntry("TimeText",	"Width", QString("%1").arg(width)));
		Time.h=atoi(cfg.readEntry("TimeText",	"Height", QString("%1").arg(height)));
		Time.line=cfg.readEntry("TimeText",		"TextLine", "%h:%m:%s");
		
		size=atoi(cfg.readEntry("TimeText",  "FontSize", "11"));
		Time.font=QFont(NULL, size, 25, false);
		
		Time.color=cfg.readEntry("TimeText",  "FontColor", "#ffffff");
	}

/// Date	
	Date.enable=atoi(cfg.readEntry( "DateText",  "Enable", "0"));
	if(Date.enable)
	{
		Date.x=atoi(cfg.readEntry("DateText",  "PosX", "0"));
		Date.y=atoi(cfg.readEntry("DateText",  "PosY", "0"));
		Date.w=atoi(cfg.readEntry("DateText",  "Width", QString("%1").arg(width)));
		Date.h=atoi(cfg.readEntry("DateText",  "Height", QString("%1").arg(height)));
		Date.line=cfg.readEntry("DateText",		"TextLine", "%d/%m/%y");
		
		size=atoi(cfg.readEntry("DateText",  "FontSize", "11"));
		Date.font=QFont(NULL, size, 25, false);
		
		Date.color=cfg.readEntry("DateText",  "FontColor", "#ffffff");
	}
	
/// Active Item	
	Item.enable=atoi(cfg.readEntry( "ActiveItemText",  "Enable", "0"));
	if(Item.enable)
	{
		Item.x=atoi(cfg.readEntry("ActiveItemText",  "PosX", "0"));
		Item.y=atoi(cfg.readEntry("ActiveItemText",  "PosY", "0"));
		Item.w=atoi(cfg.readEntry("ActiveItemText",  "Width", QString("%1").arg(width)));
		Item.h=atoi(cfg.readEntry("ActiveItemText",  "Height", QString("%1").arg(height)));
		
		size=atoi(cfg.readEntry("ActiveItemText",  "FontSize", "11"));
		Item.font=QFont(NULL, size, 25, false);
		
		Item.color=cfg.readEntry("ActiveItemText",  "FontColor", "#ffffff");
	}

/// Active Path	
	Path.enable=atoi(cfg.readEntry( "ActiveFolderText",  "Enable", "0"));
	if(Path.enable)
	{
		Path.x=atoi(cfg.readEntry("ActiveFolderText",  "PosX", "0"));
		Path.y=atoi(cfg.readEntry("ActiveFolderText",  "PosY", "0"));
		Path.w=atoi(cfg.readEntry("ActiveFolderText",  "Width", QString("%1").arg(width)));
		Path.h=atoi(cfg.readEntry("ActiveFolderText",  "Height", QString("%1").arg(height)));
		
		size=atoi(cfg.readEntry("ActiveFolderText",  "FontSize", "11"));
		Path.font=QFont(NULL, size, 25, false);
		
		Path.color=cfg.readEntry("ActiveFolderText",  "FontColor", "#ffffff");
	}
	
/// CPU
	Cpu.enable=atoi(cfg.readEntry( "CpuText",  "Enable", "0"));
	if(Cpu.enable)
	{
		Cpu.x=atoi(cfg.readEntry("CpuText",	"PosX", "0"));
		Cpu.y=atoi(cfg.readEntry("CpuText",	"PosY", "0"));
		Cpu.w=atoi(cfg.readEntry("CpuText",	"Width", QString("%1").arg(width)));
		Cpu.h=atoi(cfg.readEntry("CpuText",	"Height", QString("%1").arg(height)));
		Cpu.line=cfg.readEntry("CpuText",	"TextLine", "%1 mHz");
		
		size=atoi(cfg.readEntry("CpuText",	"FontSize", "11"));
		Cpu.font=QFont(NULL, size, 25, false);
		
		Cpu.color=cfg.readEntry("CpuText",  "FontColor", "#ffffff");
		
		cpu_round=atoi(cfg.readEntry("CpuText",	"RoundValue", "0"));
	}
	
/// Battery Volume
	BatVol.enable=atoi(cfg.readEntry( "BatteryVolumeText",  "Enable", "0"));
	if(BatVol.enable)
	{
		BatVol.x=atoi(cfg.readEntry("BatteryVolumeText",	"PosX", "0"));
		BatVol.y=atoi(cfg.readEntry("BatteryVolumeText",	"PosY", "0"));
		BatVol.w=atoi(cfg.readEntry("BatteryVolumeText",	"Width", QString("%1").arg(width)));
		BatVol.h=atoi(cfg.readEntry("BatteryVolumeText",	"Height", QString("%1").arg(height)));
		BatVol.line=cfg.readEntry("BatteryVolumeText",		"TextLine", "bat:%1");
		
		size=atoi(cfg.readEntry("BatteryVolumeText",		"FontSize", "11"));
		BatVol.font=QFont(NULL, size, 25, false);
		
		BatVol.color=cfg.readEntry("BatteryVolumeText",		"FontColor", "#ffffff");
		//if (col!="")cpuCol=QColor(atoi(col.left(3)), atoi(col.mid(4,3)), atoi(col.right(3)));
		//else		cpuCol=QColor(0, 0, 0);
	}
	
	cfg.flush();
	
/// Lang SoftKeys
	leftSoft=lng_Options;
	rightSoft=lng_Back;
	
/// Lang Week

	//"Пн|Вт|Ср|Чт|Пт|Сб|Вс"
	int pos=0;
	for(int i=0;i<7;i++)
	{
		pos = lng_week.find("|");
		week[i] = lng_week.left(pos);
		lng_week.remove(0, pos+1);
	}
	/*week[0] = tr("TXT_RID_MONTHHEADERCELL_MONDAY",	"Mn");	//Пн
	week[1] = tr("TXT_RID_MONTHHEADERCELL_TUESDAY",		"Tu");	//Вт
	week[2] = tr("TXT_RID_MONTHHEADERCELL_WEDNESDAY",	"We");	//Ср
	week[3] = tr("TXT_RID_MONTHHEADERCELL_THURSDAY",	"Th");	//Чт
	week[4] = tr("TXT_RID_MONTHHEADERCELL_FRIDAY",		"Fr");	//Пт
	week[5] = tr("TXT_RID_MONTHHEADERCELL_SATURDAY",	"Sa");	//Сб
	week[6] = tr("TXT_RID_MONTHHEADERCELL_SUNDAY",		"Su");	//Вс*/

/// Lang Month
	
	//"Января|Февраля|Марта|Апреля|Мая|Июня|Июля|Августа|Сентября|Октября|Ноября|Декабря"
	for(int i=0;i<12;i++)
	{
		pos = lng_month.find("|");
		month[i] = lng_month.left(pos);
		lng_month.remove(0, pos+1);
	}
	/*month[0] = tr("TXT_RID_STANDARD_JANUARY",	"January");		//Январь
	month[1] = tr("TXT_RID_STANDARD_FEBRUARY",	"February");	//Февраль
	month[2] = tr("TXT_RID_STANDARD_MARCH",		"March");		//Март
	month[3] = tr("TXT_RID_STANDARD_APRIL",		"April");		//Апрель
	month[4] = tr("TXT_RID_STANDARD_MAY",		"May");			//Май
	month[5] = tr("TXT_RID_STANDARD_JUNE",		"June");		//Июнь
	month[6] = tr("TXT_RID_STANDARD_JULY",		"July");		//Июль
	month[7] = tr("TXT_RID_STANDARD_AUGUST",	"August");		//Август
	month[8] = tr("TXT_RID_STANDARD_SEPTEMBER",	"September");	//Сентябрь
	month[9] = tr("TXT_RID_STANDARD_OCTOBER",	"October");		//Октябрь
	month[10] = tr("TXT_RID_STANDARD_NOVEMBER",	"November");	//Ноябрь
	month[11] = tr("TXT_RID_STANDARD_DECEMBER",	"December");	//Декабрь*/
	
	setFullScreenMode(width, height);
	resize(width, height);
	move(240-width, 320-height);
	//bg_buf->resize(width, height);

	//qDebug("resize ok");
}
	
void kMenuWidget::slotQCopReceived(const QCString &msg, const QByteArray& data)
{
	qDebug("kMMenu::reseive mes - "+msg);
	//if(!show_app)	showMenu();
	//else			hideMenu();
	if(msg=="switch" || msg=="SHOWMAINMENU")
	{
		showMenu();
		//iconGrid->showMenu();//
	}
	
	if(msg=="changeSkin")
	{
		readMainConfig();
		
		readConfig(cfg_name);
		iconGrid->readSkinCfg();
		QPixmapCache::clear();
	}
	
	if(msg=="InstallApp(int, QString, QString, int)")
	{
		QDataStream stream( data, IO_ReadOnly );
        Q_INT32 d;
        QString appUid;
        stream >> d >> appUid;
		if(d==1)
			phonedb->search_add(appUid);
		if(d==2)
			carddb->search_add(appUid);
		
		iconGrid->readItemsCfg(UserMenuTree, iconGrid->curId);
	}
}

bool kMenuWidget::eventFilter(QObject* o, QEvent* pEvent)
{ 
    if (QEvent::KeyPress == pEvent->type())
    {
		QKeyEvent *pKey = (QKeyEvent*)pEvent;

		if(pKey->key() == 0x1031) //	Red
		{
			iconGrid->hideMenu();
			return true;
		}
	}
    return QWidget::eventFilter( o, pEvent ); 
}
