/**********************************************************
kMMenu for E2 v0.1b

Written  by Strelok Vlad Kolerts
5/12/2009
Email: admin@mobsk.org.ua
ICQ: 497123239
***********************************************************/

#include <ZKbMainWidget.h>
#include <ZConfig.h>
#include <SETUP_API.h>


#include <qcopchannel_qws.h>
#include <qpixmapcache.h>
//#include <qtextstream.h>
#include <qdatastream.h>
#include <qdatetime.h>
#include <qtimer.h>
#include <qfile.h>

#include "kIconGrid.h"

//extern "C" void UTIL_SetSideKeyLock(int);
typedef struct 
{
	int time;
	int timeout;
	int direction;
	int bat;
	int cur;
} BAT_INFO;

typedef struct 
{
	bool	enable;
	int		x;
	int		y;
	QString	line;
	QPixmap	icon;
} icon_indicator;

typedef struct 
{
	bool	enable;
	int		x;
	int		y;
	int		w;
	int		h;
	QColor	color;
	QFont	font;
	QString	line;
	QString	text;
} text_indicator;

class kMenuWidget : public ZKbMainWidget
{
    Q_OBJECT

public:
    kMenuWidget(QString cfg);
    //~kMenuWidget();
	QString cfg_name;
	
	QPainter	p;
	QPixmap* 	bg_buf;
	QPixmap		BatCharge;
	
	QColor		bgColor;
	QColor		softColor;
	QFont		softFont;
	
	icon_indicator	Signal;
	icon_indicator	Bat;
	icon_indicator	Bt;
	icon_indicator	Gprs;
	
	text_indicator	Time;
	text_indicator	Date;
	text_indicator	Item;
	text_indicator	Path;
	text_indicator	Cpu;
	text_indicator	BatVol;

	QString leftSoft,rightSoft;
	int charge_type, charge, ch, bt_search, cpu_round;
	QString week[7], month[12];

	int tmp_signal, tmp_bat, tmp_bt, tmp_gprs, tmp_h, tmp_m, tmp_s, tmp_d, tmp_mo, tmp_y;

	int infocus_delay, outfocus_delay, charge_delay;
	int width, height;
	
	kIconGrid*		iconGrid;
	
	QCopChannel *cop;
	QCopChannel *cop_am;
	QCopChannel *cop_am_reg;
	SETUP_API* api;
	
	QTimer*	timer;

	bool show_app, 	focus;
	
	QString		Wallpaper;
	void readConfig(QString cfg_name);

	void paint();
	void set_paints();
	
	void loadPic(QPixmap &pic, QString way);

	//QString kGetPath ( const char*ChineseString );
	//void Debug( QString print);
	//bool debug;
	//void readCfgItem(QString id, QString place, QString item_path);
	void focusOut();
	void focusIn();
	void focusInEvent(QFocusEvent* event);
	void focusOutEvent(QFocusEvent* event);
	
public slots:
	void MainProcess();
	void repaint();
	void showMenu();
	void hideMenu();
	void updateActiveItem();
	void updateActivePath();
	void changeFocus(bool);
	void changeSoftKeysName(QString, QString);
	void slotQCopReceived(const QCString &msg, const QByteArray& data);

protected:
	bool  eventFilter( QObject *, QEvent * );
};
