/**********************************************************
kMMenu for E2 v0.1b

Written  by Strelok Vlad Kolerts
5/12/2009
Email: admin@mobsk.org.ua
ICQ: 497123239
***********************************************************/
#include "kOptionsMenu.h"
#include "QDaemonApp.h"
///#include <AM_LauncherInterface.h>
//#include "ZMsg.h"
//#include "exec.h"

extern QDaemonApp* app;

kOptionsMenu::kOptionsMenu(QCString CopWidget) : 
    QWidget(NULL, "kOptionsMenu")
	{
		//connect(app, SIGNAL(signalRaise()), this, SLOT(showMenu()));
		it_c=f_x=f_chx=0;f_xx=-1;f_c=10;
		copWidget=CopWidget;
		
		//p_bg.load(path+skin_name+"/option_bg.png");
		//readConfig();
		cursor_h=26;//skin
		sbsCol=QColor(0,0,0);//skin
		sbCol=QColor(0,140,250);//skin
		sb_w=2;//skin
		nameCol=QColor(240,240,240);//skin
		nameCol_act=QColor(250,250,250);//skin
		nameCol_unact=QColor(160,160,160);//skin
		nameSize=15;//skin
		cursor3d=1;//skin
		anim_enable=1;//skin
		animation=5;//skin
		anim_delay=1;//skin
		anim_key_delay=20;//skin
		width=180;height=200;
		
		setBackgroundMode(NoBackground);
		resize(width, height);
		move(0, 320-height);//-soft_h
		up=down=launch=false;
		show_app=true;
		quit=false;
		path=kGetPath(QString(qApp->argv()[0]));
		click_anim=0;
		font=QFont(NULL, 15, 25, false);
		font_act=QFont(NULL, 15, 87, false);
		
		font.setPixelSize(nameSize);
		font_act.setPixelSize(nameSize);
		
		bg_buf = new QPixmap(width, height);
		cursor=QPixmap(width, cursor_h);
		
		timer = new QTimer(this);
		connect( timer, SIGNAL(timeout()), SLOT(keyBoardProcess()) );
		
		p.begin( bg_buf ,this);
		//set_paints();
		//QTimer::singleShot(100, this, SLOT(showMenu()));
	}
/*
kOptionsMenu::~kOptionsMenu()
	{
	}*/
	
void kOptionsMenu::showOptionMenu()
{
	if(cursor_h*h<200)
		height=cursor_h*h;
	else
		height=200;
	resize(width, height);
	move(0, 320-height);//-soft_h
	set_paints();
	
	paint(0);
	show_app=true;
	show();
	//app->slotRaise();
}

void kOptionsMenu::hideOptionMenu()
{
	f_x=0;f_c=10;f_xx=-1; 
	cur_it=h_vis_s=0;
	show_app=false;
	up=down=false;
	launch=false;
	timer->stop();
	hide();
}

void kOptionsMenu::runFunction()
{
	qDebug(QString("send to %1").arg(copWidget));
	QCopChannel::send(copWidget, optItem[cur_it].Func);
	hideOptionMenu();
}

void kOptionsMenu::addItem(QString name, QString func,/* QString icon,*/ int type)
{
	option_item tmp;
	tmp.Name=name;
	tmp.Func=func;
	/*if(!icon.isNull())
		tmp.Icon=QPixmap(icon);*/
	tmp.Type=type;
	
	optItem.push_back(tmp);
	//qDebug(optItem[it_c].Name+QString(" %1").arg(it_c));
	it_c++;
	
	set_paints();
}
void kOptionsMenu::changeItem(int id, QString name, QString func,/* QString icon,*/ int type)
{
	if(!name.isNull())
		optItem[id].Name=name;
	if(!func.isNull())
		optItem[id].Func=func;
	/*if(!icon.isNull())
		optItem[id].Icon=QPixmap(icon);*/
	if(type!=0)
		optItem[id].Type=type;
}
void kOptionsMenu::delItem(int id)
{
	//optItem.deleteItem(id);
	set_paints();
}
void kOptionsMenu::clear()
{
	optItem.clear();
	it_c=0;
}
	
void kOptionsMenu::set_paints()
	{
		scroll_w=sb_w+2;
		
		cur_it=0;
		h_vis=(height)/(cursor_h);
		h_vis_s=h_vis_change=0;
		
		h=it_c;//optItem.count();
		scrollsize=h_vis*(height)/h;
		
		drawCursor();
	}
	
void kOptionsMenu::drawCursor()
{
	QPainter ptmp;
	ptmp.begin( &cursor ,this);
	ptmp.setPen(sbCol);
	ptmp.fillRect(0, 0, width, cursor_h, QBrush(sbCol));
	if(cursor3d)
	{
		int r=sbCol.red();int g=sbCol.green();int b=sbCol.blue();
		r+=40;g+=40;b+=40;
		if(r>255)r=255;if(g>255)g=255;if(b>255)b=255;
		ptmp.setPen(QColor(r,g,b));
		ptmp.drawLine(0, 0, width, 0);
		r=sbCol.red();g=sbCol.green();b=sbCol.blue();
		for(int i=cursor_h/2;i<cursor_h;i++)
		{
			r-=5;g-=5;b-=5;
			if(r<0)r=0;if(g<0)g=0;if(b<0)b=0;
			ptmp.setPen(QColor(r,g,b));
			ptmp.drawLine(0, i, width, i);
		}
	}
	ptmp.end();
}

void kOptionsMenu::paint(int anim)
	{
		int y_anim=0, y_anim_c=0, y_anim_i=0, d=1, anim_step=0;
	
		if(anim)
		{
			if(up) {d=1;}
			if(down) {d=-1;}
			anim_step=cursor_h/(anim+1);
			
			y_anim=cursor_h-anim_step;
		}
		do
		{
			///anim_obj_set
			if(h_vis_change==h_vis_s)
			{
				y_anim_c=y_anim;
				y_anim_i=0;
			}
			else
			{
				y_anim_i=y_anim;
				y_anim_c=0;
			}
			
			///bg
			
			//p.drawPixmap(0, 0, p_bg);
			p.setPen(QColor(80,80,80));
			p.setBrush(QColor(50,50,50));
			p.drawRect(0, 0, width, height);
			
			///cursor
			int cur_y=cursor_h*(cur_it-h_vis_s)+y_anim_c*d;
			p.drawPixmap(1, cur_y, cursor);
			//p.fillRect(1, cur_y, width, cursor_h, QBrush(sbCol));
			
			/// Items
			int anim_line_down=0;
			if(down && h_vis_s>0)
				anim_line_down=-1;
			for(int j=h_vis_s+anim_line_down; j<(h_vis+h_vis_s+1); j++)
			{
				if(j>=h || quit)
					break;
				int y=cursor_h*(j-h_vis_s)+y_anim_i*(-d);
				//p.drawPixmap(x+c, y+c, optItem[j].Icon);
				
				int f_f=nameSize-2+(cursor_h-nameSize)/2;
				p.setPen(nameCol);
				QFont f;
				f=font;
				int x=0;
				if(j==cur_it)
				{
					p.setPen(nameCol_act);
					if(launch)
						f=font_act;
					QFontMetrics fm(f);
					int leight_name=fm.width(optItem[j].Name);
					if(leight_name>width)
					{
						f_chx=leight_name;
						x=f_x;
					}
					else
						f_chx=0;
				}
				if(optItem[j].Type==1 || optItem[j].Type==-1)
				{
					p.setPen(nameCol_unact);
					f=font;
				}
				p.setFont(f);
				
				//qDebug("paint "+optItem[j].Name+QString(" ::ok").arg(y));
				//
				//if(leight_name>width)
				p.drawText(5+x, y+f_f, optItem[j].Name, -1);
			}
			
			///scroll
			int s_size=h-h_vis;	if(s_size<1)s_size=1;
			int scroll=h_vis_change*(height-2-scrollsize)/(s_size);
			
			p.setPen(sbsCol);
			p.drawRect(width-(sb_w+2), 0, sb_w+2, height);
			p.setPen(sbCol);
			p.fillRect(width-(sb_w+1), 1+scroll, sb_w, scrollsize, QBrush(sbCol));
			
			///
			repaint();
			
			///anim_check
			anim--;
			if(anim<=0)
			{
				y_anim=0;
				h_vis_change=h_vis_s;
			}
			else
			{
				y_anim=y_anim-anim_step;
			}
			delay(anim_delay);
		}
		while(anim>=0 && !quit);
		delay(anim_key_delay);
	}

void kOptionsMenu::repaint()
	{
		bitBlt( this, 0, 0, bg_buf );
		//qDebug(QString("kOptionsMenu::repaint"));
	}

void kOptionsMenu::keyBoardProcess()
{
	qApp->processEvents();
	
	if(up)		cur_it=(cur_it+h-1)%h;
	if(down)	cur_it=(++cur_it)%h;

	if(up||down)
	{
		f_x=0;f_c=10;f_xx=-1; 
		
		if(cur_it<0)cur_it=0;
		
		while(optItem[cur_it].Type==-1)
		{
			if(up)	cur_it=(cur_it+h-1)%h;
			if(down)	cur_it=(++cur_it)%h;
			if(cur_it<0)cur_it=0;
		}
		
		h_vis_s=(cur_it+1)-h_vis;
		if(h_vis_s<0)h_vis_s=0;
		/*
		if(!down && h_vis_s!=0 && cur_j!=h-1)
		{
			if((h_vis-h_vis_s)!=cur_j)h_vis_s=h_vis_change;
		}*/
		paint(animation);
	}
	
	if(f_chx)
	{
		if(f_c>0)
			f_c--;
		else
		{
			f_x=f_x+f_xx;
			if(f_chx+f_x<=width-12 || f_x>=2)
				f_xx=-f_xx;
			paint(0);
		}
	}
}

void kOptionsMenu::keyPressEvent(QKeyEvent *event)
	{
		//printf("KEY: %x\n", event->key());
		switch (event->key())
		{
			case 0x1004: //	Center
				if(!launch && optItem[cur_it].Type!=1)
				{
					launch=true;
					paint(0);
				}
			break;
			
			case 0x1014: //	Right
				if(!launch && optItem[cur_it].Type!=1)
				{
					launch=true;
					paint(0);
				}
			break;
			case 0x1012: //	Left
				hideOptionMenu();
			break;
			case 0x1013: //	Up
				up=true;
			break;
			case 0x1015: //	Down
				down=true;
			break;
			
			case 0x1031: //	Red
				hideOptionMenu();
			break;
			
			case 0x103a: //	RightSoft
				hideOptionMenu();
			break;
			
			case 0x1032: //	c
				hideOptionMenu();
			break;
			
			case 0x1016: //	VolumeUp
				up=true;
			break;
			case 0x1017: //	VolumeDown
				down=true;
			break;
			
			case 48:
				if(skin_name!="skin/")
				{
					readSkinCfg();
				}
			break;
			
			case 42://	*
				anim_enable=!anim_enable;
				animEnable();
			break;
			
			default:
			break;
		}
	}
	
void kOptionsMenu::keyReleaseEvent(QKeyEvent *event)
	{
		switch (event->key())
		{
			case 0x1004:
				if(launch)
				{
					launch=false;
					runFunction();
					paint(0);
				}
			break;
			
			case 0x1014: //	Right
				if(launch)
				{
					launch=false;
					runFunction();
					paint(0);
				}
			break;
			
			case 0x1013: //	Up
				up=false;
			break;
			case 0x1015: //	Down
				down=false;
			break;
			
			case 0x1016: //	VolumeUp
				up=false;
			break;
			case 0x1017: //	VolumeDown
				down=false;
			break;
			
			default:
			break;
		}
	}


void kOptionsMenu::animEnable()
{
	if(anim_enable)
	{
		animation=5;//animation_t;
		anim_delay=1;//anim_delay_t;
		anim_key_delay=20;//anim_key_delay_t;
	}
	else
	{
		animation=0;
		anim_delay=0;
		anim_key_delay=80;
	}
	ZConfig cfg(path+skin_name+"/skin_options.ini", true);
	cfg.writeEntry(QString("Setting"), QString("AnimationEnable"), QString("%1").arg(anim_enable));
	cfg.flush();
}
	
void kOptionsMenu::readConfig()
	{
		ZConfig cfg(path+"/kMMenu.cfg", true);
		skin_name="skin/"+cfg.readEntry(QString("Setting"), QString("Skin"), "");
		if(skin_name!="skin/")
			readSkinCfg();
		cfg.flush();
	}

void kOptionsMenu::readSkinCfg()
	{
		int tmp=0;
		QString col="";
		
		ZConfig cfg(path+skin_name+"/skin_options.ini", true);
		
		tmp=atoi(cfg.readEntry(QString("Setting"), QString("AnimationEnable"), ""));
		anim_enable=tmp;
		tmp=atoi(cfg.readEntry(QString("Setting"), QString("Animation"), ""));
		if(tmp<1)tmp=1;
		animation_t=tmp;
		tmp=atoi(cfg.readEntry(QString("Setting"), QString("AnimationDelay"), ""));
		if(tmp<1)tmp=1;
		anim_delay_t=tmp;
		tmp=atoi(cfg.readEntry(QString("Setting"), QString("AnimationKeyDelay"), ""));
		if(tmp<1)tmp=1;
		anim_key_delay_t=tmp;
		
		col=cfg.readEntry(QString("ScrollBar"), QString("BgColor"), "");
		if (col!="")sbsCol=QColor(atoi(col.left(3)), atoi(col.mid(4,3)), atoi(col.right(3)));
		else		sbsCol=QColor(0, 0, 0);
		col=cfg.readEntry(QString("ScrollBar"), QString("Color"), "");
		if (col!="")sbCol=QColor(atoi(col.left(3)), atoi(col.mid(4,3)), atoi(col.right(3)));
		else		sbCol=QColor(255, 255, 255);
		tmp=atoi(cfg.readEntry(QString("ScrollBar"), QString("ScrollWidth"), ""));
		if(tmp!=0)	sb_w=tmp;
		else		sb_w=1;
		
		tmp=atoi(cfg.readEntry(QString("FontIconName"), QString("Size"), ""));
		if(tmp!=0)	nameSize=tmp;
		else		nameSize=9;
		col=cfg.readEntry(QString("FontIconName"), QString("Color"), "");
		if (col!="")nameCol=QColor(atoi(col.left(3)), atoi(col.mid(4,3)), atoi(col.right(3)));
		else		nameCol=QColor(255, 255, 255);
		col=cfg.readEntry(QString("FontIconName"), QString("ActiveColor"), "");
		if (col!="")nameCol_act=QColor(atoi(col.left(3)), atoi(col.mid(4,3)), atoi(col.right(3)));
		else		nameCol_act=QColor(255, 255, 255);
		cfg.flush();
		
		animEnable();
		set_paints();
	}
	
void kOptionsMenu::focusOutEvent(QFocusEvent * event)
{
	qDebug("kTaskMan::Options out focus");
	//hideOptionMenu();
}

void kOptionsMenu::focusInEvent(QFocusEvent * event)
{
	qDebug("kTaskMan::Options in focus");
	timer->start(60);
	QTimer::singleShot(100, this, SLOT(repaint()));
	//showMenu();
}

void kOptionsMenu::delay(int msec)
{
	struct timespec elapsed, tv;
	elapsed.tv_sec = msec/1000;
	elapsed.tv_nsec = (msec%1000)*1000000;
	tv.tv_sec = elapsed.tv_sec;
	tv.tv_nsec = elapsed.tv_nsec;
	nanosleep(&tv, &elapsed);
}
QString kOptionsMenu::kGetPath ( const char*ChineseString )
{
  QString str = ChineseString;
  int i = str.findRev ( "/" );
  str.remove ( i+1, str.length() - i );
  return str;
}
