/**********************************************************
kMMenu for E2 v0.1b

Written  by Strelok Vlad Kolerts
5/12/2009
Email: admin@mobsk.org.ua
ICQ: 497123239
***********************************************************/
#include "kShowDlg.h"
#include "QDaemonApp.h"

extern void vibrate(int duration, int level);
extern void Debug( QString print);
extern QDaemonApp* a;

extern QString path, skin_name;
extern QString lng_Cancel, lng_Ok;

kShowDlg::kShowDlg() : 
    QWidget(NULL, "kShowDlg")
	{
		height=320;
		show_app=true;edit_line=false;
		
		setBackgroundMode(NoBackground);
		//resize(width, height);
		//move(x, 320-height);
		
		titleFont=QFont(NULL, 15, 87, false);
		textFont=QFont(NULL, 15, 25, false);
		//editFont=QFont(NULL, 15, 25, false);
		softFont=QFont(NULL, 15, 25, false);
		
		bg_buf = new QPixmap(240, 320);
		
		line = new ZLineEdit(this, "LineEdit");
		line->setInsertionMethod(ZLineEdit::Selection);
		//line->setCellHeight(editFont.pixelSize()+4);
		//line->setFixedHeight(editSize+4);
		//line->setFont(editFont);
		line->setTitle("");
		
		readSkinCfg();
		
		/*menu = new kOptionsMenu ( "kMMenu::TextEdit::Options");
		menu->clear();
		
		menu->addItem("Copy text", "copy", 2);
		menu->addItem("Paste text", "paste", 2);
		menu->addItem("----------", NULL, 1);
		menu->addItem("Cancel", "cancel", 2);
		
		menu->hideOptionMenu();
		
		cop_menu = new QCopChannel("kMMenu::TextEdit::Options", this);
		connect( cop_menu, SIGNAL(received(const QCString&, const QByteArray&)), this, SLOT( optionFunction(const QCString&) ) );*/
		
		p.begin( bg_buf ,this);
	}
/*	
void optionFunction(const QCString&)
{
	
}*/

void kShowDlg::setText(QString str)
{
	Text.clear();
	//str.replace( QString("	"), QString::fromUtf8( "     " ));
	//str.replace( QRegExp("\10\13"), "\n");
	
	QFontMetrics fm( textFont );
	int len=0;
	int pos=0;
	int maxWidth = width - fm.maxWidth() - 10;
	int posTo=0;
	int spasePos=0;
	int spaseLen=0;
	
	while ( pos < (int)str.length() )
	{
		posTo = str.find('\n',pos);
		
		if ( posTo < 0 )
			posTo = str.length();
		
		spasePos = pos;
		spaseLen = 0;
    	len=0;
    	for (int i=pos; i<posTo; i++)
		{
			len += fm.width( str[i] );

			if ( str[i] == ' ' )
			{
				spasePos = i;
				spaseLen = len;
			}				
			if ( len > maxWidth )
			{
				if ( spasePos == pos )
				{
					Text.append(str.mid(pos, i-pos+1 ));
					pos = i+1;
					len = 0;
					spaseLen = 0;
				} else
				{
					Text.append(str.mid( pos, spasePos-pos ));
					pos = spasePos+1;
					len = len-spaseLen;
				}
				spasePos = pos;
			}
		}
		
		if  ( pos != posTo )
		{
			Text.append(str.mid(pos,posTo-pos));
		}

		pos = posTo+1;
	}
	line_h=fm.height();
}
void kShowDlg::initSoftKey(QString lSoft, QString rSoft)
{
	leftSoft=lSoft;
	rightSoft=rSoft;
	lsoft=rsoft=0;
}

bool kShowDlg::Show(QString title, QString text, int type)
{
	edit_line=false;line->hide();
	warning=0;question=1;reply=0;
	
	if(!type)
	{
		warning=1;
		initSoftKey(NULL, lng_Ok);
	}
	if(type==1)
		initSoftKey(NULL, lng_Ok);
	if(type==2)
		initSoftKey(lng_Cancel, lng_Ok);
	if(type==3)
	{
		initSoftKey(NULL, NULL);
		question=0;
	}
	
	Title=title;
	setText(text);

	height=titleHeight+padding+(Text.count()*(line_h+4))+padding+softHeight-4;
	resize(width, height);
	move(x, 320-height);

	setFocus();
	paint();
	show();
	
	int y=height;
	while(y>0)
	{
		y-=2;
		bitBlt( this, 0, y, bg_buf );
		qApp->processEvents();
	}
	bitBlt( this, 0, 0, bg_buf );
	
	vibrate(vibr_duration, vibr_level);
	while(question)
	{
		qApp->processEvents();
	}
	return reply;
}

bool kShowDlg::Show(QString title, QString text, QString edittext)
{
	edit_line=true;line->hide();
	warning=0;question=1;reply=0;
	
	initSoftKey(lng_Cancel, lng_Ok);
	
	Title=title;
	setText(text);
	line->setText(edittext);
	
	height=titleHeight+padding+(Text.count()*(line_h+4))+padding+softHeight+line->height();
	resize(width, height);
	move(x, 320-height);
	line->move(5, height-line->height()-padding-softHeight);
	
	setFocus();
	paint();
	show();

	int y=height;
	while(y>0)
	{
		y-=2;
		bitBlt( this, 0, y, bg_buf );
		qApp->processEvents();
	}
	bitBlt( this, 0, 0, bg_buf );
	
	showLine();
	
	vibrate(vibr_duration, vibr_level);
	while(question)
	{
		qApp->processEvents();
	}
	return reply;
}

void kShowDlg::paint()
	{
		///bg
		
		//p.drawPixmap(0, 0, p_bg);
		p.setPen(QPen(bgCol, borderSize, SolidLine));
		p.setBrush(bgBrushCol);
		p.drawRect(0, 0, width, height);
		
		///Title
		p.setPen(bgTitleCol);
		p.setBrush(bgBrushTitleCol);
		p.drawRect(0, 0, width, titleHeight);
		
		if(!warning)
			p.setPen(titleCol);
		else
			p.setPen(title_warnCol);
		p.setFont(titleFont);
		p.drawText(0, 0, width, titleHeight, Qt::AlignCenter, Title, -1);
		
		///Text
		int pos_h=titleHeight+padding;
		p.setPen(textCol);
		p.setFont(textFont);
		
		int line_i=0;
		while(line_i<(int)Text.count())
		{
			p.drawText(0, pos_h, width,	line_h, Qt::AlignHCenter, Text[line_i], -1);
			pos_h+=line_h+4;
			line_i++;
		}
		
		///SoftKeys
		int w_soft=width/2;
		int h_soft=height-softHeight;
		p.setFont(softFont);
		if(!lsoft)
		{
			p.setPen(softLineCol);
			p.setBrush(softBgCol);
		}
		else
		{
			p.setPen(softLine_actCol);
			p.setBrush(softBg_actCol);
		}
		p.drawRect(0, h_soft, w_soft, softHeight);
		
		if(!rsoft)
		{
			p.setPen(softLineCol);
			p.setBrush(softBgCol);
		}
		else
		{
			p.setPen(softLine_actCol);
			p.setBrush(softBg_actCol);
		}
		p.drawRect(w_soft, h_soft, w_soft, softHeight);
		
		if(!lsoft)
			p.setPen(softCol);
		else
			p.setPen(soft_actCol);
		p.drawText(0, h_soft, w_soft, softHeight, Qt::AlignCenter, leftSoft, -1);
		
		if(!rsoft)
			p.setPen(softCol);
		else
			p.setPen(soft_actCol);
		p.drawText(w_soft, h_soft, w_soft, softHeight, Qt::AlignCenter, rightSoft, -1);

		repaint();
	}

void kShowDlg::repaint()
	{
		if(edit_line)
			line->hide();
		bitBlt( this, 0, 0, bg_buf );
		/*if(edit_line && !lsoft && !rsoft)
		{
			qApp->processEvents();
			//QTimer::singleShot(100, this, SLOT(showLine()));
			showLine();
		}*/
		
		//line->setFocus();
		//Debug(QString("kShowDlg::repaint"));
	}

void kShowDlg::showLine()
	{
		if(edit_line && !lsoft && !rsoft)
			line->show();
		line->setFocus();
		line->selectAll();
	}

void kShowDlg::keyPressEvent(QKeyEvent *event)
{
	//printf("KEY: %x\n", event->key());
	switch (event->key())
	{
		case 0x1004: //	Center
			if(edit_line)
				line->setFocus();
		break;
		
		case 0x1013: //	Up
			if(edit_line)
				line->setFocus();
		break;
		case 0x1015: //	Down
			if(edit_line)
				line->setFocus();
		break;
		
		case 0x1031: //	Red
			if(question)	reply=false;
			question=false;
			hide();
		break;
		
		case 0x1038:
			if(!leftSoft.isNull() && !lsoft)
			{
				lsoft=1;
				paint();
			}
		break;
		
		case 0x103a: //	RightSoft
			if(!rightSoft.isNull() && !rsoft)
			{
				rsoft=1;
				paint();
			}
		break;
		
		default:
		break;
	}
}
void kShowDlg::keyReleaseEvent(QKeyEvent *event)
{
	switch (event->key())
	{
		case 0x1038:
			if(lsoft)
			{
				lsoft=0;
				reply=false;
				question=false;
				hide();
			}
		break;
		
		case 0x103a: //	RightSoft
			if(rsoft)
			{
				rsoft=0;
				reply=true;
				question=false;
				hide();
			}
		break;
		
		default:
		break;
	}
}

void kShowDlg::readSkinCfg()
	{
		//width=240;x=0;padding=20;//skin
		
		//bgCol=QColor(80, 80, 80);//skin
		//bgBrushCol=QColor(250, 250, 250);//skin
		//bgTitleCol=QColor(80, 80, 80);//skin
		//bgBrushTitleCol=QColor(30, 30, 30);//skin
		
		//titleCol=QColor(0,140,250);//skin
		//title_warnCol=QColor(250,60,0);//skin
		//textCol=QColor(10,10,10);//skin
		
		//softLineCol=QColor(20,20,20);//skin
		//softLine_actCol=QColor(30,30,30);//skin
		//softBgCol=QColor(20, 20, 20);//skin
		//softBg_actCol=QColor(30, 30, 30);//skin
		//softCol=QColor(250, 250, 250);//skin
		//soft_actCol=QColor(0,140,250);//skin
		
		//titleHeight=50;//skin
		//titleSize=19;//skin
		//textSize=13;//skin
		//editHeight=24;//skin
		//editSize=17;//skin
		//softHeight=20;//skin
		//softSize=15;//skin
		
		
		ZConfig cfg(path+skin_name+"/ShowDlg.ini", true);
		
		width=atoi(cfg.readEntry(QString("Setting"),		QString("Width"), "240"));
		x=atoi(cfg.readEntry(QString("Setting"),			QString("PosX"), "0"));
		vibr_duration=atoi(cfg.readEntry(QString("Setting"),QString("VibrateDuration"), "0"));
		if(vibr_duration<0)vibr_duration=0;
		vibr_level=atoi(cfg.readEntry(QString("Setting"),	QString("VibrateLevel"), "3"));
		if(vibr_level<0)vibr_level=0;if(vibr_level>3)vibr_level=3;
		
		bgBrushCol=cfg.readEntry(QString("MainRegion"),		QString("BgColor"), "#ffffff");
		bgCol=cfg.readEntry(QString("MainRegion"),			QString("BorderColor"), "#000000");
		borderSize=atoi(cfg.readEntry(QString("MainRegion"),QString("BorderSize"), "1"));
		textCol=cfg.readEntry(QString("MainRegion"),		QString("FontColor"), "#111111");
		textSize=atoi(cfg.readEntry(QString("MainRegion"),	QString("FontSize"), "13"));
		padding=atoi(cfg.readEntry(QString("MainRegion"),	QString("VerticalPadding"), "20"));
		
		titleHeight=atoi(cfg.readEntry(QString("Title"),	QString("Height"), "50"));
		bgBrushTitleCol=cfg.readEntry(QString("Title"),		QString("BgColor"), "#111111");
		bgTitleCol=cfg.readEntry(QString("Title"),			QString("BorderColor"), "#555555");
		titleCol=cfg.readEntry(QString("Title"),			QString("FontColor"), "#0088FF");
		title_warnCol=cfg.readEntry(QString("Title"),		QString("FontErrorColor"), "#ff3300");
		titleSize=atoi(cfg.readEntry(QString("Title"),		QString("FontSize"), "19"));
		
		softHeight=atoi(cfg.readEntry(QString("SoftKey"),	QString("Height"), "20"));
		softBgCol=cfg.readEntry(QString("SoftKey"),			QString("BgColor"), "#111111");
		softLineCol=cfg.readEntry(QString("SoftKey"),		QString("BorderColor"), "#111111");
		softCol=cfg.readEntry(QString("SoftKey"),			QString("FontColor"), "#ffffff");
		softBg_actCol=cfg.readEntry(QString("SoftKey"),		QString("BgActiveColor"), "#111111");
		softLine_actCol=cfg.readEntry(QString("SoftKey"),	QString("BorderActiveColor"), "#111111");
		soft_actCol=cfg.readEntry(QString("SoftKey"),		QString("FontActiveColor"), "#0088ff");
		softSize=atoi(cfg.readEntry(QString("SoftKey"),		QString("FontSize"), "15"));
		
		editHeight=atoi(cfg.readEntry(QString("EditLine"),	QString("Height"), "24"));
		editSize=atoi(cfg.readEntry(QString("EditLine"),	QString("FontSize"), "17"));
		
		cfg.flush();
		
		titleFont.setPixelSize(titleSize);
		textFont.setPixelSize(textSize);
		//editFont.setPixelSize(editSize);
		softFont.setPixelSize(softSize);
		
		//bg_buf->resize(width, height);
		//qDebug("show resize ok");
		
		line->setFixedWidth(width-10);
		line->setFontPercent(editSize/10);
		line->setFixedHeight(editHeight);
	}
	
void kShowDlg::focusOutEvent(QFocusEvent *)
{
	Debug("ShowDlg out focus");
	//hideOptionMenu();
}

void kShowDlg::focusInEvent(QFocusEvent *)
{
	Debug("ShowDlg in focus");
	QTimer::singleShot(100, this, SLOT(repaint()));
	//showMenu();
}
