#include "zTaskMan.h"
#include "lng.h"

#include <ZSoftKey.h>
#include <ZConfig.h>
#include <dirent.h>
#include <ZComboBox.h>
#include <ZApplication.h>

extern ZTaskMan *zTaskMan;

ZLng::ZLng()
{
	// Menu
	LNG_SHOW = "";
	LNG_QUIT = "";
	LNG_KILL = "";
	LNG_INFO = "";
	LNG_UPDATE = "";
	LNG_SETTING = "";
	LNG_ABOUT = "";
	LNG_EXIT = "";
	LNG_ADD = "";
	LNG_DEL = "";

	// SoftKey
	LNG_OK = "";
	LNG_MENU = "";
	LNG_CANCEL = "";
	LNG_SEL = "";

	//
	LNG_MINIALL = "";

	// Title
	LNG_DLG_ABOUT = "";
	LNG_DLG_SETTING = "";
	LNG_DLG_PROCINFO = "";
	LNG_DLG_ADD = "";

	//ZSettingDlg
	LNG_PROCFILTER = "";
	LNG_JAVAICON = "";
	LNG_NATIVICON = "";
	LNG_TASKNOWIN = "";
	LNG_SENDREASEPHONE = "";
	LNG_SENDTOIDLE = "";
	LNG_UPDATEONRAISE = "";
	LNG_RUNICON = "";
	LNG_LANG = "";
	
	//ZProcInfo
	LNG_LOADLIB = "";
}

ZLng::~ZLng()
{
	//
}

void ZLng::loadLngFile(QString fname, bool utf8)
{
	zTaskMan->toLog("loadLngFile: fname->"+ProgDir+"/lng/"+fname);
	ZConfig cfg( ProgDir+"/lng/"+fname );
	//ZConfig cfg( zTaskMan->getProgramDir()+"/lng/"+fname , false );
	//ZConfig cfg( zTaskMan->ProgDir+"/lng/"+fname , false );
	
	LNG_SHOW = QString::fromUtf8(cfg.readEntry("Menu", QString("SHOW"), "SHOW").utf8());
	LNG_QUIT = QString::fromUtf8(cfg.readEntry("Menu", QString("QUIT"), "QUIT").utf8());
	LNG_KILL = QString::fromUtf8(cfg.readEntry("Menu", QString("KILL"), "KILL").utf8());
	LNG_INFO = QString::fromUtf8(cfg.readEntry("Menu", QString("INFO"), "INFO").utf8());
	LNG_UPDATE = QString::fromUtf8(cfg.readEntry("Menu", QString("UPDATE"), "UPDATE").utf8());
	LNG_SETTING = QString::fromUtf8(cfg.readEntry("Menu", QString("SETTING"), "SETTING").utf8());
	LNG_ABOUT = QString::fromUtf8(cfg.readEntry("Menu", QString("ABOUT"), "ABOUT").utf8());
	LNG_EXIT = QString::fromUtf8(cfg.readEntry("Menu", QString("EXIT"), "EXIT").utf8());
	LNG_ADD = QString::fromUtf8(cfg.readEntry("Menu", QString("ADD"), "ADD").utf8());
	LNG_DEL = QString::fromUtf8(cfg.readEntry("Menu", QString("DEL"), "DEL").utf8());
	
	LNG_OK = QString::fromUtf8(cfg.readEntry("SoftKey", QString("OK"), "OK").utf8());
	LNG_MENU = QString::fromUtf8(cfg.readEntry("SoftKey", QString("MENU"), "MENU").utf8());
	LNG_CANCEL = QString::fromUtf8(cfg.readEntry("SoftKey", QString("CANCEL"), "CANCEL").utf8());
	LNG_SEL = QString::fromUtf8(cfg.readEntry("SoftKey", QString("SEL"), "SEL").utf8());
	
	LNG_DLG_ABOUT = QString::fromUtf8(cfg.readEntry("Title", QString("DLG_ABOUT"), "DLG_ABOUT").utf8());
	LNG_DLG_SETTING = QString::fromUtf8(cfg.readEntry("Title", QString("DLG_SETTING"), "DLG_SETTING").utf8());
	LNG_DLG_PROCINFO = QString::fromUtf8(cfg.readEntry("Title", QString("DLG_PROCINFO"), "DLG_PROCINFO").utf8());
	LNG_DLG_ADD = QString::fromUtf8(cfg.readEntry("Title", QString("DLG_ADD"), "DLG_ADD").utf8());	
	
	LNG_PROCFILTER = QString::fromUtf8(cfg.readEntry("SettingDlg", QString("PROCFILTER"), "PROCFILTER").utf8());
	LNG_JAVAICON = QString::fromUtf8(cfg.readEntry("SettingDlg", QString("JAVAICON"), "JAVAICON").utf8());
	LNG_PID = QString::fromUtf8(cfg.readEntry("SettingDlg", QString("SHOWPID"), "JAVAICON").utf8());
	LNG_NATIVICON = QString::fromUtf8(cfg.readEntry("SettingDlg", QString("NATIVICON"), "NATIVICON").utf8());
	LNG_TASKNOWIN = QString::fromUtf8(cfg.readEntry("SettingDlg", QString("TASKNOWIN"), "TASKNOWIN").utf8());
	LNG_SENDREASEPHONE= QString::fromUtf8(cfg.readEntry("SettingDlg", QString("SENDREASEPHONE"), "SENDREASEPHONE").utf8());
	LNG_SENDTOIDLE = QString::fromUtf8(cfg.readEntry("SettingDlg", QString("SENDTOIDLE"), "SENDTOIDLE").utf8());
	LNG_UPDATEONRAISE = QString::fromUtf8(cfg.readEntry("SettingDlg", QString("UPDATEONRAISE"), "UPDATEONRAISE").utf8());
	LNG_RUNICON = QString::fromUtf8(cfg.readEntry("SettingDlg", QString("RUNICON"), "RUNICON").utf8());
	LNG_LANG = QString::fromUtf8(cfg.readEntry("SettingDlg", QString("LANG"), "LANG").utf8());
	
	LNG_LOADLIB = QString::fromUtf8(cfg.readEntry("ProcInfo", QString("LOADLIB"), "LOADLIB").utf8());
	
	LNG_MINIALL = QString::fromUtf8(cfg.readEntry("Interface", QString("MINIALL"), "MINIALL").utf8());
	
	cfg.flush();
	zTaskMan->toLog("loadLngFile: end");
}

void ZLng::getLngList(/*ZComboBox *list*/QStringList list, QString cur)
{
	zTaskMan->toLog("getLngList");
	static DIR *dir;
	struct dirent *entry;
	char *name;
	QString qname;
	QString lang;		

	dir = opendir( ProgDir + "/lng");
	//dir = opendir(zTaskMan->getProgramDir() + "/lng");
	if(!dir)
	{
		zTaskMan->toLog("getLngList: Can't open SD Card", true, true);
	} else	
	{
		/**int i;
		i=0;*/
		for(;;) 
		{	
			if((entry = readdir(dir)) == NULL) 
			{
				closedir(dir);
				dir = 0;
				break;
			}	
			name = entry->d_name;
			qname = QString(name);
			if (qname.find(".lng")>-1)
			{
				zTaskMan->toLog("getLngList: LNG->"+ qname);
				//ZConfig cfg( QString(zTaskMan->getProgramDir() + "/lng/"+ qname) );
				ZConfig cfg( QString( ProgDir + "/lng/"+ qname) );
				lang = cfg.readEntry(QString("Info"), QString("LNG"), "-").utf8();
				cfg.flush();
				list.append(QString::fromUtf8(lang));
				/**list->insertItem(QString::fromUtf8(lang),i);
				if (qname==cur)
					list->setCurrentItem(i);
				++i;*/
			}
		}	
	}
	zTaskMan->toLog("getLngList: end");
}

QString ZLng::getLngFileName(QString lname)
{
	zTaskMan->toLog("getLngFileNam");
	static DIR *dir;
	struct dirent *entry;
	char *name;
	QString qname;
	QString lang;		

	//dir = opendir(zTaskMan->getProgramDir() + "/lng");
	dir = opendir( ProgDir + "/lng");
	if(!dir)
	{
		zTaskMan->toLog("getLngList: Can't open SD Card", true, true);
	} else	
	{
		for(;;) 
		{	
			if((entry = readdir(dir)) == NULL) 
			{
				closedir(dir);
				dir = 0;
				break;
			}	
			name = entry->d_name;
			qname = QString(name);
			if (qname.find(".lng")>-1)
			{
				zTaskMan->toLog("getLngFileNam: LNG->"+ qname);
				//ZConfig cfg( QString(zTaskMan->getProgramDir() + "/lng/"+ qname) );
				ZConfig cfg( QString( ProgDir + "/lng/"+ qname) );
				lang = cfg.readEntry(QString("Info"), QString("LNG"), "-");
				if (lang == lname)
				{
					cfg.flush();
					zTaskMan->toLog("getLngFileNam: "+qname);
					return qname;
				}
				cfg.flush();
			}
		}	
	}
	zTaskMan->toLog("getLngFileNam: end");
	return "";
}
