//
// C++ Interface: zTaskMan
//
// Description:
//
//
// Author: Ant-ON <bezols@gmail.com>, (C) 2009
//
#ifndef ZGUI_H
#define ZGUI_H

#include <qobject.h>
#include <unistd.h>
#include <stdlib.h>

#include <ZMessageDlg.h>
#include <ZKbMainWidget.h>
#include <qmap.h>

#include "kListBox.h"
#include "kOptionsMenu.h"

#include <qcopchannel_qws.h>

class BDRegistry
{
public:
    BDRegistry(){}
    ~BDRegistry(){}

	QString icon() const { return icon_; }
	QString name() const { return name_; }
	bool t() const { return t_; }
	void setIcon( QString salary ) { icon_ = salary; }
	void setName( QString salary ) { name_ = salary; }
	void setT( bool salary ) { t_ = salary; }

private:
	QString icon_;
	QString name_;
	bool t_;
};

class ZTaskMan : public ZKbMainWidget
{
    Q_OBJECT
  public:
    ZTaskMan();
    ~ZTaskMan();
    
	kListBox *lbProc;
	int pidPhone;

	QPixmap pm_app;
	QPixmap pm_java;
	QPixmap pm_fav;
	bool java_name;

    QString getProgramDir();
    QString ProgDir;
    void CreateWindow();  
    void toLog(QString mes, bool r1 = false , bool r2 = false );
    void buildProcList();
    void nativIcon();
    void kvmToName();
    QString getJavaFolderInSD();
    QString extractExecName(QString nameProc);
	bool procFilter(QString nameProc);    
	bool procFilterSh(QString nameProc);       
	bool addedProc(int pid);
	void pidToTop(int pid);
	void goToIdle();
	void sendMes(int pid, QString mes);
	bool processIsRuning( pid_t pid );
	bool pidKill( int pid);
	void pidQuit( int pid );	
	QString readFileLine(const QString & fileName);
	void createProcMenu();
	
	void readCfg();
	bool cfg_SendReaisePhone;
	bool cfg_SendGoToIDLE;
	bool cfg_UpdateOnRaise;
	bool cfg_FiltrProc;    
	bool cfg_ShowJavaIcon;
	bool cfg_ShowPid; 
    bool cfg_ShowNativIcon; 
    bool cfg_ShowAppNoWindow;
    bool cfg_ShowIconOnRunApp;
    QString cfg_Lang;
	
	bool key_note, key_voice, key_play, key_next, key_prew, key_vol_up, key_vol_dwn;
    
  public slots:
    void about();
    void lbProcSel(int index); 

    void slotRaise();
    void slotReturnToIdle( int reason );
    
    void showOptions();
	void menu_procShow();
    void menu_procQuit();  
    void menu_procKill(); 
    void menu_procInfo();   
    void menu_appSetting();
    
  	void signalReceived(const QCString&, const QByteArray&);
	void optionFunction(const QCString&);

  private:
	kOptionsMenu* menu;
	QCopChannel* cop_menu;
	QCopChannel* cop_hardkey;
    QCopChannel* channelStart;
    
  protected:
    bool  eventFilter( QObject *, QEvent * );
};

#endif
